<?php
/*************************************************************************/
/* DOCEBO LCMS - Learning Content Managment System                       */
/* ======================================================================*/
/* Docebo is the new name of SpaghettiLearning Project                   */
/*                                                                       */
/* Copyright (c) 2005 by Emanuele Sandri (esandri@tiscali.it)            */
/*                                                                       */
/* This program is free software. You can redistribute it and/or modify  */
/* it under the terms of the GNU General Public License as published by  */
/* the Free Software Foundation; either version 2 of the License.        */
/*************************************************************************/

function adminManager_list() {
	checkPerm('view');

	require_once($GLOBALS['where_framework'].'/lib/lib.newtypeone.php');

	$lang =& DoceboLanguage::createInstance('admin_manager', 'framework');
	$aclManager = new DoceboACLManager();

	// get users to show
	$admin_group_idst = $aclManager->getGroupST( ADMIN_GROUP_ADMIN );
	$arr_admin_idst = $aclManager->getGroupUMembers( $admin_group_idst );
	$arr_admin_id = array_flip($aclManager->getArrUserST( $arr_admin_idst ));

	$table = new typeOne( 	$GLOBALS['visuItem'],
							$lang->def('_ADMIN_MANAGMENT_CAPTION'),
							$lang->def('_ADMIN_MANAGMENT_SUMMARY') );
	$table->initNavBar('ini', 'link');
	$table->setLink('index.php?modname=admin_manager&amp;op=view&amp;ini=');

	$ini = $table->getSelectedElement();
	//$ini = importVar( 'ini', true, 0);

	// getTitleArea(testo, nomeimmagine , alt immagine)
	$GLOBALS['page']->add(
		getTitleArea($lang->def('_ADMIN_MANAGMENT'), 'admin_managmer', $lang->def('_ADMIN_MANAGMENT'))
		.'<div class="std_block">', 'content');

	$contentH 	= array( 	$lang->def( '_ADMIN_USERID' ),
							'<img src="'.getPathImage().'admin_manager/man_pref.gif" alt="'.$lang->def( '_ADMIN_PREFERENCES' ).'" '
								.'title="'.$lang->def( '_ADMIN_PREFERENCES_TITLE' ).'" />',

							'<img src="'.getPathImage().'admin_manager/man_menu.gif" alt="'.$lang->def( '_ADMIN_MENU' ).'" '
								.'title="'.$lang->def( '_ADMIN_MENU_TITLE' ).'" />',

							'<img src="'.getPathImage().'admin_manager/man_course.gif" alt="'.$lang->def( '_ADMIN_ASSIGNCOURSE' ).'" '
								.'title="'.$lang->def( '_ADMIN_ASSIGNCOURSE_TITLE' ).'" />',
							'<img src="'.getPathImage().'directory/tree.gif" alt="'.$lang->def( '_ADMIN_ASSIGNTREE' ).'" '
								.'title="'.$lang->def( '_ADMIN_ASSIGNTREE_TITLE' ).'" />');
	$typeH 		= array( '', 'image', 'image', 'image', 'image');

	$table->setColsStyle($typeH);
	$table->addHead($contentH);

	$maxItem = ( count($arr_admin_id) < ( $ini + $GLOBALS['visuItem'] ) )
		? count($arr_admin_id)
		: $ini + $GLOBALS['visuItem'];

	for( $index = $ini; $index < $maxItem; $index++ ) {

		$admin_userid = substr($arr_admin_id[$arr_admin_idst[$index]], 1);
		$rowContent = array($admin_userid);

		// Edit preferences
		$rowContent[] = '<a href="index.php?modname=admin_manager&amp;op=edit_preferences&amp;adminidst='.$arr_admin_idst[$index].'"
						 title="'.$lang->def( '_ADMIN_PREFERENCES_TITLE' ).' : '.$admin_userid.'">'
						.'<img src="'.getPathImage().'admin_manager/man_pref.gif"'
							.' alt="'.$lang->def( '_ADMIN_PREFERENCES' ).' : '.$admin_userid.'" /></a>';

		// Edit menu
		$rowContent[] = '<a href="index.php?modname=admin_manager&amp;op=edit_menu&amp;adminidst='.$arr_admin_idst[$index].'"
						 title="'.$lang->def( '_ADMIN_MENU_TITLE' ).' : '.$admin_userid.'">'
						.'<img src="'.getPathImage().'admin_manager/man_menu.gif"'
							.' alt="'.$lang->def( '_ADMIN_MENU' ).' : '.$admin_userid.'" /></a>';

		// Edit course
		$rowContent[] = '<a href="index.php?modname=admin_manager&amp;op=edit_course&amp;adminidst='.$arr_admin_idst[$index].'&amp;load=1"
						 title="'.$lang->def( '_ADMIN_ASSIGNCOURSE_TITLE' ).' : '.$admin_userid.'">'
						.'<img src="'.getPathImage().'admin_manager/man_course.gif"'
							.' alt="'.$lang->def( '_ADMIN_ASSIGNCOURSE' ).' : '.$admin_userid.'" /></a>';

		// Edit user
		$rowContent[] = '<a href="index.php?modname=admin_manager&amp;op=assign_tree&amp;adminidst='.$arr_admin_idst[$index].'"
		 					title="'.$lang->def( '_ADMIN_ASSIGNTREE_TITLE' ).' : '.$admin_userid.'">'
						.'<img src="'.getPathImage().'directory/tree.gif" '
							.'alt="'.$lang->def( '_ADMIN_ASSIGNTREE' ).' : '.$admin_userid.'" /></a>';

		$table->addBody($rowContent);
	}

	$GLOBALS['page']->add(
		$table->getTable()
		.$table->getNavBar($ini, count($arr_admin_id)),'content');

	$GLOBALS['page']->add( '</div>', 'content' );
}

function adminManager_assign_tree( $adminidst ) {
	checkPerm('view');
	if( $adminidst == 0 )
		return;
	require_once($GLOBALS['where_framework'].'/lib/lib.form.php');
	require_once($GLOBALS['where_framework'].'/class.module/class.directory.php');
	require_once($GLOBALS['where_framework'].'/lib/lib.adminmanager.php');
	$directory = new Module_Directory();
	$lang =& DoceboLanguage::createInstance('admin_manager', 'framework');
	$aclManager = new DoceboACLManager();
	$adminManager = new AdminManager();
	if( isset($_POST['okselector']) ) {

		$arr_selected = $directory->getSelection($_POST);
		$arr_unselected = $directory->getUnselected();
		foreach( $arr_unselected as $idstTree )
			$adminManager->removeAdminTree( $idstTree, $adminidst );
		foreach( $arr_selected as $idstTree )
			$adminManager->addAdminTree( $idstTree, $adminidst );
		jumpTo( 'index.php?modname=admin_manager&amp;op=view' );
	} elseif( isset($_POST['cancelselector']) ) {
		jumpTo( 'index.php?modname=admin_manager&amp;op=view' );
	} else {
		if( !isset($_GET['stayon']) ) {
			$directory->resetSelection($adminManager->getAdminTree($adminidst));
		}
		$admin_info = $aclManager->getUser($adminidst, false);
		$directory->show_user_selector = FALSE;
		$directory->show_group_selector = TRUE;
		$directory->show_orgchart_selector = TRUE;
		$directory->show_orgchart_simple_selector = TRUE;
		$directory->multi_choice = TRUE;
		$directory->loadSelector('index.php?modname=admin_manager&amp;op=assign_tree&amp;adminidst='.$adminidst.'&amp;stayon=1',
						$lang->def( '_ADMIN_ASSIGNTREE' ),
						$lang->def( '_ADMIN_ASSIGNTREEDESCR' ).' : '
							.'<span class="text_bold">'.substr($admin_info[ACL_INFO_USERID], 1).'</span>',
						TRUE);
	}

}

function adminManager_edit_preferences() {
	checkPerm('view');

	require_once($GLOBALS['where_framework'].'/lib/lib.form.php');
	require_once($GLOBALS['where_framework'].'/lib/lib.preference.php');

	$lang =& DoceboLanguage::createInstance('admin_manager', 'framework');
	$aclManager =& $GLOBALS['current_user']->getAclManager();

	$adminidst = importVar('adminidst', true, 0);
	$user_pref = new UserPreferences($adminidst);

	if(isset($_POST['save_pref'])) {

		$user_pref->savePreferences($_POST);
		jumpTo('index.php?modname=admin_manager&op=view');
	}
	$admin_info = $aclManager->getUser($adminidst, false);
	$GLOBALS['page']->add(
		getTitleArea($lang->def('_ADMIN_MANAGMENT'), 'admin_managmer', $lang->def('_ADMIN_MANAGMENT'))
		.'<div class="std_block">'
		.Form::getFormHeader($lang->def('_ADMIN_SPECIAL_SETTING').' '.substr($admin_info[ACL_INFO_USERID], 1))
		.Form::openForm('admin_preferences', 'index.php?modname=admin_manager&amp;op=edit_preferences')
		.Form::openElementSpace()
		.Form::getHidden('adminidst', 'adminidst', $adminidst)

		.$user_pref->getModifyMask('admin_rules')

		.Form::closeElementSpace()
		.Form::openButtonSpace()
		.Form::getButton('save_pref', 'save_pref', $lang->def('_SAVE'))
		.Form::getButton('undo_pref', 'undo_pref', $lang->def('_UNDO'))
		.Form::closeElementSpace()
		.'</div>', 'content');
}

function adminManager_edit_menu() {
	checkPerm('view');

	require_once($GLOBALS['where_framework'].'/lib/lib.form.php');
	require_once($GLOBALS['where_framework'].'/lib/lib.tab.php');
	require_once($GLOBALS['where_framework'].'/lib/lib.adminmanager.php');

	$lang 			=& DoceboLanguage::createInstance('admin_manager', 'framework');
	$aclManager 	=& $GLOBALS['current_user']->getAclManager();
	$adminidst 		= importVar('adminidst', true, 0);
	$out 			=& $GLOBALS['page'];

	$admin_manager 			= new AdminManager();
	$all_admin_permission 	=& $admin_manager->getAdminPermission($adminidst);
	
	$old_tab = importVar('tab');
	if(isset($_POST['tabelem_lms_status'])) 		$active_tab = 'lms';
	elseif(isset($_POST['tabelem_cms_status'])) 	$active_tab = 'cms';
	elseif(isset($_POST['tabelem_global_status'])) 	$active_tab = 'global';
	else $active_tab = importVar('tab', false, 'global');

	//instance class-------------------------------------------
	require_once($GLOBALS['where_framework'].'/class/class.conf.php');
	switch($active_tab) {
		case "global" : {
			require_once($GLOBALS['where_framework'].'/class/class.admin_menu_fw.php');
			$admin_menu = new Admin_Managment_Framework();
		};break;
		case "lms" : {
			require_once($GLOBALS['where_lms'].'/class/class.admin_menu_lms.php');
			$admin_menu = new Admin_Managment_Lms();
		};break;
		case "cms" : {
			require_once($GLOBALS['where_cms'].'/class/class.admin_menu_cms.php');
			$admin_menu = new Admin_Managment_Cms();
		};break;
	}

	// save if is it required
	if(isset($_POST['save_permission'])) {
		
		$re = $admin_menu->savePreferences($_POST, $adminidst, $all_admin_permission);
		jumpTo('index.php?modname=admin_manager&op=view&result='.($re ? 1 : 0 ));
	}


	//prefetching tab-------------------------------------------
	$tabs = new TabView('admin_menu_tab_editing', 'index.php?modname=admin_manager&amp;op=edit_menu&amp;adminidst='.$adminidst);

	$global_tab = new TabElemDefault('global', $lang->def('_MENU_MANAGE_GLOBAL'), getPathImage().'main_zone/framework.gif');
	$tabs->addTab($global_tab);
	if($GLOBALS['where_lms'] !== false) {
		$lms_tab = new TabElemDefault('lms', $lang->def('_MENU_MANAGE_LMS'), getPathImage().'main_zone/lms.gif');
		$tabs->addTab($lms_tab);
	}
	if($GLOBALS['where_cms'] !== false) {
		$cms_tab = new TabElemDefault('cms', $lang->def('_MENU_MANAGE_CMS'), getPathImage().'main_zone/cms.gif');
		$tabs->addTab($cms_tab);
	}
	$tabs->setActiveTab($active_tab);
	$out->setWorkingZone('content');

	$out->add(
		getTitleArea($lang->def('_ADMIN_MANAGMENT'), 'admin_managmer', $lang->def('_ADMIN_MANAGMENT'))
		.'<div class="std_block">'
		.$tabs->printTabView_Begin()
		.Form::openForm('admin_menu_editing', '')
		.Form::getHidden('adminidst', 'adminidst', $adminidst)
		.Form::getHidden('tab', 'tab', $active_tab)

		.$admin_menu->getPermissionUi($all_admin_permission, 'admin_menu_editing')

		.Form::openButtonSpace()
		.Form::getButton('save_permission', 'save_permission', $lang->def('_SAVE'))
		.Form::getButton('undo_pref', 'undo_pref', $lang->def('_UNDO'))
		.Form::closeButtonSpace()

		.Form::closeForm()
		.$tabs->printTabView_End()
		.'</div>');
}

function updateEntry(&$new_sel, &$old_sel, $type, $user) {

	$re = true;
	$to_add 	= array_diff($new_sel, $old_sel);
	$to_del 	= array_diff($old_sel, $new_sel);
	while(list(,$id_c) = each($to_add)) {

		$re &= mysql_query("
		INSERT INTO ".$GLOBALS['prefix_fw']."_admin_course
		( id_entry, type_of_entry, idst_user ) VALUES
		( '".$id_c."', '".$type."', '".$user."') ");
	}
	while(list(,$id_c) = each($to_del)) {

		$re &= mysql_query("
		DELETE FROM ".$GLOBALS['prefix_fw']."_admin_course
		WHERE id_entry = '".$id_c."' AND type_of_entry = '".$type."' AND idst_user = '".$user."'");
	}
	return $re;
}

function adminManager_edit_course() {
	checkPerm('view');

	require_once($GLOBALS['where_lms'].'/lib/lib.course_managment.php');

	$lang 		=& DoceboLanguage::createInstance('admin_manager', 'framework');
	$adminidst 	= importVar('adminidst', true, 0);
	$out 		=& $GLOBALS['page'];
	$out->setWorkingZone('content');

	$sel = new Course_Manager();
	$sel->setLink('index.php?modname=admin_manager&amp;op=edit_course');

	if(isset($_GET['load']) || isset($_POST['save_selection'])) {

		$course_initial_sel = array();
		$coursepath_initial_sel = array();
		$catalogue_initial_sel = array();
		$query = "
		SELECT id_entry, type_of_entry
		FROM ".$GLOBALS['prefix_fw']."_admin_course
		WHERE idst_user = '".$adminidst."'";
		$re_entry = mysql_query($query);
		while(list($id, $type) = mysql_fetch_row($re_entry)) {

			switch($type) {
				case "course" : 		$course_initial_sel[$id] = $id;break;
				case "coursepath" : 	$coursepath_initial_sel[$id] = $id;break;
				case "catalogue" : 		$catalogue_initial_sel[$id] = $id;break;
			}
		}
		if(isset($_GET['load'])) {
			$sel->resetCourseSelection($course_initial_sel);
			$sel->resetCoursePathSelection($coursepath_initial_sel);
			$sel->resetCatalogueSelection($catalogue_initial_sel);
		}
	}
	if(isset($_POST['save_selection'])) {

		$re = true;
		$course = $sel->getCourseSelection($_POST);
		$re &= updateEntry($course, $course_initial_sel, 'course', $adminidst);

		$coursepath = $sel->getCoursePathSelection($_POST);
		$re &= updateEntry($coursepath, $coursepath_initial_sel, 'coursepath', $adminidst);

		$catalogue = $sel->getCatalogueSelection($_POST);
		$re &= updateEntry($catalogue, $catalogue_initial_sel, 'catalogue', $adminidst);

		jumpTo('index.php?modname=admin_manager&amp;op=view&amp;result='.( $re ? 'ok' : 'err' ));
	}
	if(isset($_POST['undo_pref'])) {
		jumpTo('index.php?modname=admin_manager&amp;op=view');
	}
	$out->addStart(
		getTitleArea($lang->def('_ADMIN_MANAGMENT'), 'admin_managmer', $lang->def('_ADMIN_MANAGMENT'))
		.'<div class="std_block">'
		.Form::openForm('admin_menu_editing', 'index.php?modname=admin_manager&amp;op=edit_course')
		.Form::getHidden('adminidst', 'adminidst', $adminidst)
		//.Form::getHidden('tab', 'tab', $active_tab)
		, 'content' );

	$out->addEnd(
		Form::openButtonSpace()
		.Form::getButton('save_selection', 'save_selection', $lang->def('_SAVE'))
		.Form::getButton('undo_pref', 'undo_pref', $lang->def('_UNDO'))
		.Form::closeButtonSpace()
		.Form::closeForm()
		.'</div>'
		, 'content' );

	$sel->loadSelector();
}

function adminManagerDispatch( $op ) {

	if(isset($_POST['undo_pref'])) $op = 'view';
	switch($op) {
		case "view" : {
			adminManager_list();
		};break;
		case "assign_tree": {
			adminManager_assign_tree(ImportVar( 'adminidst', true, 0));
		};break;

		// Extra preferences and settings
		case "edit_preferences" : {
			adminManager_edit_preferences();
		};break;

		// Menu managment
		case "edit_menu" : {
			adminManager_edit_menu();
		};break;


		// Course managment
		case "edit_course" : {
			adminManager_edit_course();
		};break;
	}
}

?>