<?php

/************************************************************************/
/* DOCEBO LMS - Learning managment system								*/
/* ============================================							*/
/*																		*/
/* Copyright (c) 2005													*/
/* http://www.docebo.com												*/
/*																		*/
/* This program is free software. You can redistribute it and/or modify	*/
/* it under the terms of the GNU General Public License as published by	*/
/* the Free Software Foundation; either version 2 of the License.		*/
/************************************************************************/

/**
 * @package  DoceboLms
 * @version  $Id: course.php 215 2006-04-06 17:15:50Z fabio $
 * @category course
 * @author   Pirovano Fabio <fabio@docebo.com>
 */

require_once($GLOBALS['where_lms'].'/lib/lib.levels.php');

function statusNoEnter($perm, $status) {
	return ( $perm & (1 << $status) );
}

function course() {
	
	require_once($GLOBALS['where_framework'].'/lib/lib.form.php');
	require_once($GLOBALS['where_framework'].'/lib/lib.lang.php');
	require_once($GLOBALS['where_framework'].'/lib/lib.newtypeone.php');
	require_once($GLOBALS['where_lms'].'/lib/lib.course.php');
	
	require_once($GLOBALS['where_framework'].'/lib/lib.sessionsave.php');
	require_once(dirname(__FILE__).'/../category/category.php');
	require_once(dirname(__FILE__).'/../category/tree.category.php');
	
	$lang =& DoceboLanguage::CreateInstance('admin_course_managment', 'lms');
	$out =& $GLOBALS['page'];
	
	$c_filter = importVar('c_filter', false);
	$c_expire = importVar('c_expire', false);
	
	$out->setWorkingZone('content');
	$out->add(getTitleArea($lang->def('_COURSE'), 'course')
		.'<div class="std_block">');
	
	$categoryDb = new TreeDb_CatDb($GLOBALS['prefix_lms'].'_category');
	$treeView = new TreeView_CatView($categoryDb, 'course_category', $lang->def('_COURSE_CATEGORY'));
	
	$o_load = new Session_Save();
	if(isset($_SESSION['course_category'])) $treeView->setState(unserialize(stripslashes($_SESSION['course_category'])));
	$treeView->parsePositionData($_POST, $_POST, $_POST);
	
	if($treeView->op) {
		
		//category operation
		$out->add(Form::openForm('course_category', 'index.php?modname=course&amp;op=course_list'));
		categoryDispatch($treeView->op, $treeView);
		$out->add(Form::closeForm());
	} else {
		
		if(isset($_GET['error'])) {
			if($_GET['error']) $out->add(getErrorUi($lang->def('_COURSE_OPERATION_FAIL')));
			else $out->add(getResultUi($lang->def('_COURSE_OPERATION_SUCCESS')));
		} 
		if(isset($_GET['result_subscribe'])) {
			switch($_GET['result_subscribe']) {
				case "ok" : {
					$out->add(getResultUi($lang->def('_SUBSCRIBE_OK')));
				};break;
				case "ok" : {
					$out->add(getResultUi($lang->def('_UNSUBSCRIBE_OK')));
				};break;
				case "err_1" : {
					$out->add(getErrorUi($lang->def('_SUBSCRIBE_SELECTION_EMPTY')));	
				};break;
				case "err_2" : {
					$out->add(getErrorUi($lang->def('_SUBSCRIBE_OPERATION_FAILURE')));	
				};break;
			}
		}
		//course normal display
		$out->add(
			Form::openForm('course_list', 'index.php?modname=course&amp;op=course_list')
			.$treeView->load()
			.$treeView->loadActions()
			.'<br />');
		
		$id_categories = array();
		$id_category = $treeView->getSelectedFolderId();
		$id_categories = $categoryDb->getDescendantsId($categoryDb->getFolderById($id_category));
		$id_categories[] = $id_category;	//add selected folder
		
		$can_add = checkPerm('add', true);
		$can_mod = checkPerm('mod', true);
		$can_del = checkPerm('del', true);
		$can_subscribe 	= checkPerm('subscribe', true);
		$can_moderate	= checkPerm('moderate', true);
		
		$flat = isset($_POST['c_flatview']);
		
		$tb = new TypeOne($GLOBALS['lms']['visu_course'], $lang->def('_COURSE_LIST_CAPTION'), $lang->def('_COURSE_LIST_SUMMARY'));
		
		$tb->initNavBar('ini', 'button');
		$ini = $tb->getSelectedElement();
		
		if(isset($_POST['sel_course'])) list($sel_id_course) = each($_POST['sel_course']);
		else $sel_id_course = false;
		
		// Retriving subscribed user
		$subscribed_user = "
		SELECT idCourse, waiting, COUNT(*)
		FROM ".$GLOBALS['prefix_lms']."_courseuser
		GROUP BY idCourse, waiting";
		$re_subscribed = mysql_query($subscribed_user);
		while(list($id_c, $wait, $num_user) = mysql_fetch_row($re_subscribed)) {
			if($wait) $waiting[$id_c] = $num_user;
			else $user_subscribed[$id_c] = $num_user;
		}
		
		$select = "SELECT c.idCourse, c.code, c.name, c.description, c.status, c.difficult, 
			c.subscribe_method, c.permCloseLo, c.show_rules, c.max_num_subscribe "; 
		$query_course = "FROM ".$GLOBALS['prefix_lms']."_course AS c
		WHERE c.idCategory IN ( ".( !$flat ? $id_category  : implode(",", $id_categories) )." )";
		
		if($GLOBALS['current_user']->getUserLevelId() != ADMIN_GROUP_GODADMIN) {
		
			require_once($GLOBALS['where_lms'].'/lib/lib.course_managment.php');
			
			$course_man = new AdminCourseManagment();
			$all_courses =& $course_man->getUserAllCourses( getLogUserId() );
			
			if(empty($all_courses)) $query_course .= " AND 0 ";
			else $query_course .= " AND c.idCourse IN (".implode(',', $all_courses).") ";
		}
		if($c_filter != '') {
			$query_course .= " AND ( "
					." c.code LIKE '%".$c_filter."%' OR "
					." c.name LIKE '%".$c_filter."%' OR "
					." c.description LIKE '%".$c_filter."%' )";
		}
		if($c_expire != '') {
			switch($c_expire) {
				case 1 : $query_course .= " AND c.date_end = '0000-00-00'";break;
				case 2 : $query_course .= " AND UNIX_TIMESTAMP(c.date_end) >= '".time()."' ";break;
				case 3 : $query_course .= " AND UNIX_TIMESTAMP(c.date_end) <= '".time()."' AND c.date_end <> '0000-00-00'";break;
			}
		}
		list($tot_course) = mysql_fetch_row(mysql_query("SELECT COUNT(*)".$query_course));
		$query_course .= " ORDER BY c.name 
							LIMIT ".$ini.",".(int)$GLOBALS['lms']['visu_course'];
		
		$re_course = mysql_query($select.$query_course);
		
		//filter---------------------------------------------------------------------
		$out->add(
		Form::getOpenFieldset($lang->def('_FILTER'))
		.Form::getTextfield($lang->def('_FILTER_INALL'), 'c_filter', 'c_filter', '255', $c_filter)
		.Form::getDropdown($lang->def('_FILTER_EXPIRE'), 'c_expire', 'c_expire', 
			array(	0 => $lang->def('_FE_NONE'), 
					1 => $lang->def('_FE_WITHOUT_EXPIRED'),
					2 => $lang->def('_FE_NOT_EXPIRED'), 
					3 => $lang->def('_FE_EXPIRED')), 
			( isset($_POST['c_expire']) ? $c_expire : 0 ) )
		
		.Form::getCheckbox($lang->def('_FILTER_FLATVIEW'), 'c_flatview', 'c_flatview', '1', 
			isset($_POST['c_flatview']), 
			' onclick="submit();" ' )
		
		
		.Form::openButtonSpace()
		.Form::getButton('filter', 'filter', $lang->def('_APPLY_FILTER'), 'button_nowh')
		.Form::closeButtonSpace()
		.Form::getCloseFieldset());
		
		//show result-------------------------------------------------------------------
		
		$col_type = array('image', '', 'align_center', 'image');
		$col_content = array(
		$lang->def('_COURSE_CODE'), 
		str_replace(
			'[more]', 
			'<img src="'.getPathImage().'standard/more.gif" alt="'.$lang->def('_MORE_INFO').'" />', 
			''.$lang->def('_COURSE_NAME_TABLE').''), 
		$lang->def('_COURSE_STATUS'), 
		$lang->def('_COURSE_USERISCR'));
		if($can_moderate) {
			$col_type[] = 'image';
			$col_content[] = '<img src="'.getPathImage('fw').'standard/moderate.gif" alt="'.$lang->def('_ALT_USERWAITING').'"' 
					.' title="'.$lang->def('_USERWAITING').'" />';
		}
		if($can_subscribe) {
			$col_type[] = 'image';
			$col_content[] = '<img src="'.getPathImage().'subscribe/add_subscribe.gif" alt="'.$lang->def('_ALT_ADD_SUSCRIBE').'"' 
					.' title="'.$lang->def('_ADD_SUBSCRIBE').'" />';
			$col_type[] = 'image';
			$col_content[] = '<img src="'.getPathImage().'subscribe/mod_subscribe.gif" alt="'.$lang->def('_ALT_MOD_SUSCRIBE').'"' 
					.' title="'.$lang->def('_MOD_SUBSCRIBE').'" />';
			$col_type[] = 'image';
			$col_content[] = '<img src="'.getPathImage().'subscribe/del_subscribe.gif" alt="'.$lang->def('_ALT_DEL_SUSCRIBE').'"' 
					.' title="'.$lang->def('_DEL_SUBSCRIBE').'" />';
		}
		//modify action ----------------------------------------------------
		if($can_mod) {
			$col_type[] = 'image';
			$col_content[] = '<img src="'.getPathImage().'course/assign_menu.gif" '
				.'alt="'.$lang->def('_ALT_ASSIGN_MENU').'" '
				.'title="'.$lang->def('_ASSIGN_MENU').'" />';
			$col_type[] = 'image';
			$col_content[] = '<img src="'.getPathImage().'standard/move.gif" '
				.'alt="'.$lang->def('_ALT_MOVE', 'standard').'" '
				.'title="'.$lang->def('_COURSE_MOVE').'" />';
				
			$col_type[] = 'image';
			$col_content[] = '<img src="'.getPathImage().'standard/mod.gif" '
				.'alt="'.$lang->def('_ALT_MOD', 'standard').'" '
				.'title="'.$lang->def('_COURSE_MODIFY').'" />';
		}
		//delete action ----------------------------------------------------
		if($can_del) {
			$col_type[] = 'image';
			$col_content[] = '<img src="'.getPathImage().'standard/rem.gif" '
				.'alt="'.$lang->def('_ALT_DEL', 'standard').'" '
				.'title="'.$lang->def('_COURSE_DELETE').'" />';
		}
		
		$tb->setColsStyle($col_type);
		$tb->addHead($col_content);
		while(list($id_course, $code, $name, $desc, $status, $difficult, $auto_sub, $end_mode, $show_rules, $max_user_sub) = mysql_fetch_row($re_course)) {
			
			$teacher =& fromIdstToUser(getSubscribed($id_course, false, 6, true));
			
			$tb_content = array();
			
			$tb_content[] = ($c_filter != ''
						? eregi_replace($c_filter, '<strong class="filter_evidence">'.$c_filter.'</strong>', $code)
						: $code );
			
			$tb_content[] = ( $id_course == $sel_id_course ? 
					'<input type="image" class="button_image" '
					.'src="'.getPathImage().'standard/less.gif" '
					.'alt="'.$lang->def('_LESS_INFO').'" '
					.'id="sel_course_0" '
					.'name="sel_course[0]"  />' : '' )
				.( $id_course != $sel_id_course ? 
					'<input type="image" class="button_image" '
					.'src="'.getPathImage().'standard/more.gif" '
					.'alt="'.$lang->def('_MORE_INFO').'" '
					.'id="sel_course_'.$id_course.'" '
					.'name="sel_course['.$id_course.']" />' : '' )
				.($c_filter != ''
						? eregi_replace($c_filter, '<strong class="filter_evidence">'.$c_filter.'</strong>', $name)
						: $name );
			
			switch($status) {
				case 0 : $tb_content[] = $lang->def('_CST_PRE_DO');break;
				case 1 : $tb_content[] = $lang->def('_CST_IN_DO');break;
				case 2 : $tb_content[] = $lang->def('_CST_AFTER_DO');break;
			}
			
			// number of user subscribed
			if(isset($user_subscribed[$id_course])) {
				$tb_content[] = $user_subscribed[$id_course].( $max_user_sub > 0 ? '/'.$max_user_sub : '' );
			} else {
				$tb_content[] = '0'.( $max_user_sub > 0 ? '/'.$max_user_sub : '' );
			}
			
			// number of user that is waiting
			if($can_moderate && isset($waiting[$id_course])) {
				
				$tb_content[] = '<a class="course_waiting_user" href="index.php?modname=subscribe&amp;op=waitinguser&amp;id_course='.$id_course.'"'
					.' title="'.$lang->def('_USERWAITING').'">'
					.'<strong>'.$waiting[$id_course].'</strong>'
					.'</a>';
			} elseif($can_moderate) {
				
				$tb_content[] = '';
			}
			
			// user subscription action
			if($can_subscribe) {
				
				$tb_content[] = '
					<a href="index.php?modname=subscribe&amp;load=1&amp;op=subscribeadd&amp;id_course='.$id_course.'"' 
						.' title="'.$lang->def('_ADD_SUBSCRIBE').'">'
					.'<img src="'.getPathImage().'subscribe/add_subscribe.gif" alt="'.$lang->def('_ALT_ADD_SUSCRIBE').'" />'
					.'</a>';
				$tb_content[] = '
					<a href="index.php?modname=subscribe&amp;op=subscribemod&amp;id_course='.$id_course.'"' 
						.' title="'.$lang->def('_MOD_SUBSCRIBE').'">'
					.'<img src="'.getPathImage().'subscribe/mod_subscribe.gif" alt="'.$lang->def('_ALT_MOD_SUSCRIBE').'" />'
					.'</a>';
				$tb_content[] = '
					<a href="index.php?modname=subscribe&amp;op=subscribedel&amp;id_course='.$id_course.'"' 
						.' title="'.$lang->def('_DEL_SUBSCRIBE').'">'
					.'<img src="'.getPathImage().'subscribe/del_subscribe.gif" alt="'.$lang->def('_ALT_DEL_SUSCRIBE').'" />'
					.'</a>';
			}
			
			// course management action
			if($can_mod) {
				$tb_content[] = '<input type="image" class="button_image" '
					.'id="assign_menu_course_'.$id_course.'" '
					.'name="assign_menu_course['.$id_course.']" '
					.'alt="'.$lang->def('_ALT_ASSIGN_MENU').'" '
					.'title="'.$lang->def('_ASSIGN_MENU').'" '
					.'src="'.getPathImage().'course/assign_menu.gif" />';
				
				
				$tb_content[] = '<input type="image" class="button_image" '
					.'id="move_course_'.$id_course.'" '
					.'name="move_course['.$id_course.']" '
					.'alt="'.$lang->def('_ALT_MOVE').'" '
					.'title="'.$lang->def('_COURSE_MOVE').'" '
					.'src="'.getPathImage().'standard/move.gif" />';
				
				$tb_content[] = '<input type="image" class="button_image" '
					.'id="mod_course_'.$id_course.'" '
					.'name="mod_course['.$id_course.']" '
					.'alt="'.$lang->def('_ALT_MOD').'" '
					.'title="'.$lang->def('_COURSE_MODIFY').'" '
					.'src="'.getPathImage().'standard/mod.gif" />';
			}
			if($can_del) {
				$tb_content[] = '<input type="image" class="button_image" '
					.'id="del_course_'.$id_course.'" '
					.'name="del_course['.$id_course.']" '
					.'alt="'.$lang->def('_ALT_DEL').'" '
					.'title="'.$lang->def('_COURSE_DELETE').'" '
					.'src="'.getPathImage().'standard/rem.gif" />';
			}
			$tb->addBody($tb_content);
			
			// extra info for the course selected
			if( $id_course == $sel_id_course ) {
				
				$GLOBALS['page']->add('<a hrf="#more_'.$id_course.'">'.$lang->def('_JUMP_TO_EXTRACOURSE_OPENED_INFO').'</a>', 'blind_navigation');
				$GLOBALS['page']->add('
				<script type="text/javascript">
					<!--
					var temp = window.onload;
					if (typeof(window.onload) != "function") {
						
						window.onload = function() {
							var extra_info = document.getElementById("more_'.$id_course.'_a");
							extra_info.focus();
						}
					} else {
						
						window.onload = function() {
							temp();
							var extra_info = document.getElementById("more_'.$id_course.'_a");
							extra_info.focus();
						}
					}
					-->
				</script>
				','page_head');
				
				// print extra info
				$extra_info = '<span id="more_'.$id_course.'">'.$lang->def('_COURSE_TEACHERS').' : </span> '
					.( count($teacher) ? implode(', ', $teacher) : $lang->def('_NONE') )
					.'<br />'
				
					.'<span>'.$lang->def('_COURSE_SUBSRIBE').' : </span> ';
				switch($auto_sub) {
					case 0 : $extra_info .= $lang->def('_COURSE_S_GODADMIN').'<br />';break;
					case 1 : $extra_info .= $lang->def('_COURSE_S_MODERATE').'<br />';break;
					case 2 : $extra_info .= $lang->def('_COURSE_S_FREE').'<br />';break;
				}
				
				$extra_info .= '<span>'.$lang->def('_WHERE_SHOW_COURSE').' : </span> '
					.( $show_rules == 0 ? $lang->def('_SC_EVERYWHERE') : '' )
					.( $show_rules == 1 ? $lang->def('_SC_ONLY_IN') : '' )
					.( $show_rules == 2 ? $lang->def('_SC_ONLYINSC_USER') : '' ).'<br />'
				.'<span>'.$lang->def('_COURSE_END_MODE').' : </span> '
				.( $end_mode ? 
						$lang->def('_COURSE_EM_TEACHER') : 
						$lang->def('_COURSE_EM_LO') ).'<br />'
				.'<a id="more_'.$id_course.'_a" name="more_'.$id_course.'_a"></a>'
				
				.'<span>'.$lang->def('_COURSE_DESCRIPTION').' : </span> '
				.'<div class="description">'
					.($c_filter != ''
						? eregi_replace($c_filter, '<strong class="filter_evidence">'.$c_filter.'</strong>', $desc)
						: $desc )
				.'</div>';
				
			$tb->addBodyExpanded($extra_info, 'course_more_info');
			}
		}
		if($can_add) {
			$tb->addActionAdd(
				Form::getButton('new_course', 'new_course', $lang->def('_COURSE_NEW'), 'transparent_add_button')
			);
		}
		
		$out->add($tb->getTable()
			.$tb->getNavBar($ini, $tot_course)
			.Form::closeForm());
	}
	
	$out->add('</div>');
	
	$_SESSION['course_category'] = addslashes(serialize($treeView->getState()));
}

function addCourse() {
	require_once($GLOBALS['where_framework'].'/lib/lib.form.php');
	require_once($GLOBALS['where_framework'].'/lib/lib.lang.php');
	require_once($GLOBALS['where_framework'].'/lib/lib.newtypeone.php');
	require_once($GLOBALS['where_lms'].'/lib/lib.course.php');
	
	require_once(dirname(__FILE__).'/../category/category.php');
	require_once(dirname(__FILE__).'/../category/tree.category.php');
	require_once($GLOBALS['where_lms'].'/lib/lib.manmenu.php');
	
	$form = new Form();
	$lang =& DoceboLanguage::CreateInstance('admin_course_managment', 'lms');
	$out =& $GLOBALS['page'];
	
	$levels = CourseLevel::getLevels();
	$array_lang = $GLOBALS['globLangManager']->getAllLangCode();
	$difficult_lang = array(
	'veryeasy' => $lang->def('_DIFFICULT_VERYEASY'),
	'easy' => $lang->def('_DIFFICULT_EASY'),
	'medium'=> $lang->def('_DIFFICULT_MEDIUM'),
	'difficult' => $lang->def('_DIFFICULT_DIFFICULT'),
	'verydifficult' => $lang->def('_DIFFICULT_VERYDIFFICULT'));
	$menu_custom = getAllCustom();
	list($sel_custom) = each($menu_custom);
	reset($menu_custom);
	
	$categoryDb = new TreeDb_CatDb($GLOBALS['prefix_lms'].'_category');
	$treeView = new TreeView_CatView($categoryDb, 'course_category', $lang->def('_COURSE_CATEGORY'));
	
	$treeView->parsePositionData($_POST, $_POST, $_POST);
	$id_category = $treeView->getSelectedFolderId();
	$name_category = $treeView->getFolderPrintName($categoryDb->getFolderById($id_category));
	
	$out->setWorkingZone('content');
	$out->add(getTitleArea($lang->def('_COURSE'), 'course')
		.'<div class="std_block">');
	
	$out->add(
		$form->getFormHeader($lang->def('_COURSE_NEW'))
		.$form->openForm('course_creation', 'index.php?modname=course&amp;op=add_course', false, false, 'multipart/form-data')
		.$form->openElementSpace()
		
		.$form->getHidden('id_category', 'id_category', $id_category)
		
		.$form->getTextBox('<span class="text_bold">'.$lang->def('_CATEGORY_SELECTED').' :</span> '.$name_category)
		.$form->getTextfield($lang->def('_COURSE_CODE'), 'course_code', 'course_code', '50', '')
		.$form->getTextfield($lang->def('_COURSE_NAME'), 'course_name', 'course_name', '255', '')
		.$form->getDropdown($lang->def('_COURSE_MENU_TO_ASSIGN'), 'selected_menu', 'selected_menu', $menu_custom, 
			$sel_custom )
		.$form->getDropdown($lang->def('_COURSE_LANG_METHOD'), 'course_lang', 'course_lang', $array_lang, 
			array_search(getLanguage(), $array_lang) )
		.$form->getDropdown($lang->def('_COURSE_DIFFICULT'), 'course_difficult', 'course_difficult', $difficult_lang, 
			'medium' )
		.$form->getDropdown($lang->def('_COURSE_STATUS'), 'course_status', 'course_status', 
			array( 0 => $lang->def('_CST_PRE_DO'), 1 =>$lang->def('_CST_IN_DO'), 2 =>$lang->def('_CST_AFTER_DO')), '0' )
		.$form->getTextarea($lang->def('_COURSE_DESCRIPTION'), 'course_descr', 'course_descr', 
			'')
		
		.'<div class="align_center">'
		.str_replace(
			'[down]', 
			'<img src="'.getPathImage().'standard/down.gif" alt="'.$lang->def('_OTHER_OPTION').'" />', 
			$lang->def('_COURSE_MORE_OPTION'))
		.'</div>'
		.$form->closeElementSpace()
		
		.$form->openButtonSpace()
			.$form->getButton('course_create', 'course_create', $lang->def('_CREATE'))
			.$form->getButton('course_undo', 'course_undo', $lang->def('_UNDO'))
		.$form->closeButtonSpace()
		.$form->openElementSpace());
	
	//-display-mode----------------------------------------------------
	$out->add(
		$form->getOpenFieldset($lang->def('_COURSE_DISPLAY_MODE'))
		
		//-list-of-user---------------------------------------------------
		.$form->getOpenCombo($lang->def('_SHOW_USER_OF_LEVEL')));
	while(list($level, $level_name) = each($levels)) {
		
		$out->add($form->getCheckbox($level_name, 'course_show_level_'.$level, 'course_show_level['.$level.']', $level));
	}
	$out->add(
		$form->getCloseCombo()
		
		//-where-show-course----------------------------------------------
		.$form->getOpenCombo($lang->def('_WHERE_SHOW_COURSE'))
		.$form->getRadio($lang->def('_SC_EVERYWHERE'), 'course_show_rules_every', 'course_show_rules', '0', true )
		.$form->getRadio($lang->def('_SC_ONLY_IN'), 'course_show_rules_only_in', 'course_show_rules', '1')
		.$form->getRadio($lang->def('_SC_ONLYINSC_USER'), 'course_show_rules_onlyinsc_user', 'course_show_rules', '2')
		.$form->getCloseCombo()
		
		//-what-show------------------------------------------------------
		.$form->getOpenCombo($lang->def('_WHAT_SHOW'))
		.$form->getCheckbox($lang->def('_SHOW_PROGRESS'), 'course_progress', 'course_progress', '1', true )
		.$form->getCheckbox($lang->def('_SHOW_TIME'), 'course_time', 'course_time', '1', true )
		.$form->getCheckbox($lang->def('_SHOW_ADVANCED_INFO'), 'course_advanced', 'course_advanced', '1' )
		.$form->getCloseCombo()
		
		.$form->getCloseFieldset());
	
	//-user-interaction--------------------------------------------------
	$out->add(
		$form->getOpenFieldset($lang->def('_USER_INTERACTION_OPTION'))
		
		//-subscribe-method-----------------------------------------------
		.$form->getOpenCombo($lang->def('_COURSE_SUBSRIBE'))
		.$form->getRadio($lang->def('_COURSE_S_GODADMIN'), 'course_subs_godadmin', 'course_subs', '0', true )
		.$form->getRadio($lang->def('_COURSE_S_MODERATE'), 'course_subs_moderate', 'course_subs', '1')
		.$form->getRadio($lang->def('_COURSE_S_FREE'), 'course_subs_free', 'course_subs', '2')
		.$form->getCloseCombo()
		
		//mode for course end---------------------------------------------
		.$form->getOpenCombo($lang->def('_COURSE_END_MODE'))
		.$form->getRadio($lang->def('_COURSE_EM_TEACHER'), 'course_em_manual', 'course_em', '1', true )
		.$form->getRadio($lang->def('_COURSE_EM_LO'), 'course_em_lo', 'course_em', '0')
		.$form->getCloseCombo()
		
		//status that can enter------------------------------------------
		.$form->getOpenCombo($lang->def('_COURSE_STATUS_CANNOT_ENTER'))
		.$form->getCheckbox($lang->def('_USER_STATUS_ISCR'), 'user_status_'._CUS_SUBSCRIBED, 'user_status['._CUS_SUBSCRIBED.']', _CUS_SUBSCRIBED)
		.$form->getCheckbox($lang->def('_USER_STATUS_BEGIN'), 'user_status_'._CUS_BEGIN, 'user_status['._CUS_BEGIN.']', _CUS_BEGIN)
		.$form->getCheckbox($lang->def('_USER_STATUS_END'), 'user_status_'._CUS_END, 'user_status['._CUS_END.']', _CUS_END)
		.$form->getCheckbox($lang->def('_USER_STATUS_SUSPEND'), 'user_status_'._CUS_SUSPEND, 'user_status['._CUS_SUSPEND.']', _CUS_SUSPEND, true)
		.$form->getCloseCombo()
		
		// max number of user that can be subscribed
		.$form->getTextfield($lang->def('_MAX_NUM_SUBSCRIBE'), 'max_num_subscribe', 'max_num_subscribe', 11, 0)
		
		// sms budget
		//.$form->getTextfield($lang->def('_MAX_SMS_BUDGET'), 'max_sms_budget', 'max_sms_budget', 11, 0)
		
		.$form->getCloseFieldset());
	
	//-expiration---------------------------------------------------------
	$out->add(
		$form->getOpenFieldset($lang->def('_COURSE_TIME_OPTION'))
		.$form->getDatefield($lang->def('_DATE_BEGIN'), 'course_date_begin', 'course_date_begin' )
		.$form->getDatefield($lang->def('_DATE_END'), 'course_date_end', 'course_date_end' )
		.$form->getTextfield($lang->def('_DAY_OF_VALIDITY'), 'course_day_of', 'course_day_of', '10', '0')
		.$form->getTextfield($lang->def('_MEDIUM_TIME'), 'course_medium_time', 'course_medium_time', '10', '0')
		.$form->getCloseFieldset());
	
	$out->add(
		$form->getOpenFieldset($lang->def('_COURSE_SELL_OPTION'))
		.$form->getCheckbox($lang->def('_SELLING'), 'course_selling', 'course_selling', '1', false)
		.$form->getTextfield($lang->def('_PRIZE'), 'course_prize', 'course_prize', '10', '')
		.$form->getCloseFieldset());
	
	//sponsor-and-logo----------------------------------------------------
	$out->add(
		$form->getTextfield($lang->def('_SPONSOR_LINK'), 'course_sponsor_link', 'course_sponsor_link', '255', 'http://')
		.$form->getFilefield($lang->def('_SPONSOR_LOGO'), 'course_sponsor_logo', 'course_sponsor_logo')
		.$form->getFilefield($lang->def('_COURSE_LOGO'), 'course_logo', 'course_logo'));
	
	$out->add(
		$form->closeElementSpace()
		.$form->openButtonSpace()
			.$form->getButton('course_create_bottom', 'course_create', $lang->def('_CREATE'))
			.$form->getButton('course_undo_bottom', 'course_undo', $lang->def('_UNDO'))
		.$form->closeButtonSpace()
	);
	
	$out->add($form->closeForm()
		.'</div>');
}

function insCourse() {
	
	require_once($GLOBALS['where_framework'].'/lib/lib.upload.php');
	
	require_once($GLOBALS['where_lms'].'/lib/lib.course.php');
	
	$array_lang	 = $GLOBALS['globLangManager']->getAllLangCode();
	$acl_man 	=& $GLOBALS['current_user']->getAclManager();
	
	if($_POST['course_name'] == '') {
		
		$_POST['course_name'] = def('_NO_NAME', 'admin_course_managment', 'lms');
	}
	
	$path = '/doceboLms/'.$GLOBALS['lms']['pathcourse'];
	if(substr($path, -1) != '/' && substr($path, -1) != '\\') {
		$path = $path.'/';
	}
	
	$user_status = 0;
	if(isset($_POST['user_status'])) {
		while(list($status) = each($_POST['user_status'])) {
			$user_status |= (1 << $status);
		}
	}
	$file_sponsor = '';
	$file_logo = '';
	$error = 0;
	$show_level = 0;
	if(isset($_POST['course_show_level'])) {
		while(list($lv) = each($_POST['course_show_level'])) {
			$show_level |= (1 << $lv);
		}
	}
	
	sl_open_fileoperations();
	require_once($GLOBALS['where_framework'].'/lib/lib.multimedia.php');

	if($_FILES['course_sponsor_logo']['tmp_name'] != '') {
		
		$file_sponsor = 'sponsor_'.mt_rand(0, 100).'_'.time().'_'.$_FILES['course_sponsor_logo']['name'];
	
		$re = createImageFromTmp($_FILES['course_sponsor_logo']['tmp_name'], 
							$path.$file_sponsor, 
							$_FILES['course_sponsor_logo']['name'],
							150,
							150,
							true );
		if($re != 0) {
			$error = 1;
			$file_sponsor = '';
		}
	}
	
	if($_FILES['course_logo']['tmp_name'] != '') {
		
		$file_logo = 'logo_'.mt_rand(0, 100).'_'.time().'_'.$_FILES['course_logo']['name'];
		$re = createImageFromTmp($_FILES['course_logo']['tmp_name'], 
							$path.$file_logo, 
							$_FILES['course_logo']['name'],
							150,
							150,
							true );
		if($re != 0) {
			$error = 1;
			$file_logo = '';
		}
	}
	
	sl_close_fileoperations();
	
	$query_course = "
	INSERT INTO ".$GLOBALS['prefix_lms']."_course 
	SET idCategory = '".( isset($_POST['id_category']) ? $_POST['id_category'] : 0 )."', 
		code = '".$_POST['course_code']."', 
		name = '".$_POST['course_name']."', 
		description = '".$_POST['course_descr']."', 
		lang_code = '".$array_lang[$_POST['course_lang']]."', 
		status = '".(int)$_POST['course_status']."', 
		level_show_user = '".$show_level."', 
		subscribe_method = '".(int)$_POST['course_subs']."', 
		linkSponsor = '".$_POST['course_sponsor_link']."', 
		imgSponsor = '".$file_sponsor."', 
		img_course = '".$file_logo."', 
		mediumTime = '".$_POST['course_medium_time']."', 
		permCloseLO = '".$_POST['course_em']."', 
		userStatusOp = '".$user_status."', 
		difficult = '".$_POST['course_difficult']."', 
		show_progress = '".( isset($_POST['course_progress']) ? 1 : 0 )."', 
		show_time = '".( isset($_POST['course_time']) ? 1 : 0 )."', 
		show_extra_info = '".( isset($_POST['course_advanced']) ? 1 : 0 )."', 
		show_rules = '".(int)$_POST['course_show_rules']."', 
		date_begin = '".$GLOBALS['regset']->regionalToDatabase($_POST['course_date_begin'], 'date')."', 
		date_end = '".$GLOBALS['regset']->regionalToDatabase($_POST['course_date_end'], 'date')."', 
		valid_time = '".(int)$_POST['course_day_of']."',
		max_num_subscribe = '".(int)$_POST['max_num_subscribe']."', 
		prize = '".(int)$_POST['course_prize']."',
		selling = '".( isset($_POST['course_selling']) ? 1 : 0 )."'";
		//, max_sms_budget = '".$_POST['max_sms_budget']."'
		
	if(!mysql_query($query_course)) {
		
		$error = 1;
		if($file_sponsor != '') sl_unlink($path.$file_sponsor);
		if($file_logo != '') sl_unlink($path.$file_logo);
		jumpTo('index.php?modname=course&op=course_list&course_category_status='.importVar('course_category_status')
			.'&error=1');
	} else {
		
		list($id_course) = mysql_fetch_row(mysql_query("SELECT LAST_INSERT_ID()"));
		// send alert
		require_once($GLOBALS['where_framework'] . '/lib/lib.eventmanager.php'); 
		
		$msg_composer = new EventMessageComposer('admin_course_management', 'lms');
		
		$msg_composer->setSubjectLangText('email', '_ALERT_SUBJECT', false);
		$msg_composer->setBodyLangText('email', '_ALERT_TEXT', array(	'[url]' => $GLOBALS['lms']['url'], 
																			'[course_code]' => $_POST['course_code'], 
																			'[course]' => $_POST['course_name'] ) );
																			
		$msg_composer->setSubjectLangText('sms', '_ALERT_SUBJECT_SMS', false);
		$msg_composer->setBodyLangText('sms', '_ALERT_TEXT_SMS', array(	'[url]' => $GLOBALS['lms']['url'], 
																			'[course_code]' => $_POST['course_code'], 
																			'[course]' => $_POST['course_name'] ) );
		
		require_once($GLOBALS['where_lms'] . '/lib/lib.course.php'); 
		$course_man = new Man_Course();
		$recipients = $course_man->getIdUserOfLevel($id_course);
		createNewAlert(	'CoursePropModified', 
						'course', 
						'add', 
						'1', 
						'Inserted course '.$_POST['course_name'], 
						$recipients, 
						$msg_composer );
	}
	
	if($GLOBALS['current_user']->getUserLevelId() != ADMIN_GROUP_GODADMIN) {
		
		$re &= mysql_query("
		INSERT INTO ".$GLOBALS['prefix_fw']."_admin_course 
		( id_entry, type_of_entry, idst_user ) VALUES 
		( '".$id_course."', 'course', '".getLogUserId()."') ");
	}
	
	//if the scs exist create a room
	if($GLOBALS['where_scs'] !== false) {
	
		require_once($GLOBALS['where_scs'].'/lib/lib.room.php');
		
		$rules = array(
					'room_name' => $_POST['course_name'], 
					'room_type' => 'course', 
					'id_source' => $id_course );
		$admin_rules = getAdminRules();
		$rules = array_merge($rules, $admin_rules);
		$re = insertRoom($rules);
	}
	$course_idst =& createCourseLevel($id_course);
	
	require_once($GLOBALS['where_lms'].'/lib/lib.manmenu.php');
	$id_custom = importVar('selected_menu');
	if(!cerateCourseMenuFromCustom($id_custom, $id_course, $course_idst)) $error = 1;
	
	jumpTo('index.php?modname=course&op=course_list&course_category_status='.importVar('course_category_status')
		.'&error='.$error);
}

function modCourse() {
	require_once($GLOBALS['where_framework'].'/lib/lib.form.php');
	require_once($GLOBALS['where_framework'].'/lib/lib.lang.php');
	require_once($GLOBALS['where_framework'].'/lib/lib.newtypeone.php');
	require_once($GLOBALS['where_lms'].'/lib/lib.course.php');
	
	require_once(dirname(__FILE__).'/../category/category.php');
	require_once(dirname(__FILE__).'/../category/tree.category.php');
	
	$form = new Form();
	$lang =& DoceboLanguage::CreateInstance('admin_course_managment', 'lms');
	$out =& $GLOBALS['page'];
	
	$levels = CourseLevel::getLevels();
	$array_lang = $GLOBALS['globLangManager']->getAllLangCode();
	$difficult_lang = array(
		'veryeasy' => $lang->def('_DIFFICULT_VERYEASY'),
		'easy' => $lang->def('_DIFFICULT_EASY'),
		'medium'=> $lang->def('_DIFFICULT_MEDIUM'),
		'difficult' => $lang->def('_DIFFICULT_DIFFICULT'),
		'verydifficult' => $lang->def('_DIFFICULT_VERYDIFFICULT'));
	
	//load data from database
	
	list($id_course) = each($_POST['mod_course']);
	$query_course = "
	SELECT code, name, description, lang_code, status, level_show_user, subscribe_method, 
		linkSponsor, mediumTime, permCloseLO, userStatusOp, difficult, 
		show_progress, show_time, show_extra_info, show_rules, date_begin, date_end, valid_time,
		max_num_subscribe, max_sms_budget, 
		prize, selling
	FROM ".$GLOBALS['prefix_lms']."_course
	WHERE idCourse = '".$id_course."'";
	
	$course = mysql_fetch_array(mysql_query($query_course));
	if(!$course['date_begin']) $course['date_begin'] = '';
	if(!$course['date_end']) $course['date_end'] = '';
	
	$lang_code = array_search($course['lang_code'], $array_lang);
	
	$out->setWorkingZone('content');
	$out->add(getTitleArea($lang->def('_COURSE'), 'course')
		.'<div class="std_block">');
	
	$out->add(
		$form->getFormHeader($lang->def('_COURSE_NEW'))
		.$form->openForm('course_creation', 'index.php?modname=course&amp;op=upd_course', false, false, 'multipart/form-data')
		.$form->openElementSpace()
		
		.$form->getHidden('id_course', 'id_course', $id_course)
		
		.$form->getTextfield($lang->def('_COURSE_CODE'), 'course_code', 'course_code', '50', $course['code'])
		.$form->getTextfield($lang->def('_COURSE_NAME'), 'course_name', 'course_name', '255', $course['name'])
		.$form->getDropdown($lang->def('_COURSE_LANG_METHOD'), 'course_lang', 'course_lang', $array_lang, 
			$lang_code )
		.$form->getDropdown($lang->def('_COURSE_DIFFICULT'), 'course_difficult', 'course_difficult', $difficult_lang, 
			$course['difficult'] )
		.$form->getDropdown($lang->def('_COURSE_STATUS'), 'course_status', 'course_status', 
			array( 0 => $lang->def('_CST_PRE_DO'), 1 =>$lang->def('_CST_IN_DO'), 2 =>$lang->def('_CST_AFTER_DO')), 
			$course['status'] )
		.$form->getTextarea($lang->def('_COURSE_DESCRIPTION'), 'course_descr', 'course_descr', 
			$course['description'])
		
		.'<div class="align_center">'
		.str_replace(
			'[down]', 
			'<img src="'.getPathImage().'standard/down.gif" alt="'.$lang->def('_OTHER_OPTION').'" />', 
			$lang->def('_COURSE_MORE_OPTION'))
		.'</div>'
		.$form->closeElementSpace()
		
		.$form->openButtonSpace()
			.$form->getButton('upd_course', 'upd_course', $lang->def('_SAVE'))
			.$form->getButton('course_undo', 'course_undo', $lang->def('_UNDO'))
		.$form->closeButtonSpace()
		
		.$form->openElementSpace());
	
	//-display-mode----------------------------------------------------
	$out->add(
		$form->getOpenFieldset($lang->def('_COURSE_DISPLAY_MODE'))
		
		//-list-of-user---------------------------------------------------
		.$form->getOpenCombo($lang->def('_SHOW_USER_OF_LEVEL')));
	while(list($level, $level_name) = each($levels)) {
		
		$out->add($form->getCheckbox($level_name, 'course_show_level_'.$level, 'course_show_level['.$level.']', $level, 
			($course['level_show_user'] & (1 << $level))));
	}
	$out->add(
		$form->getCloseCombo()
		
		//-where-show-course----------------------------------------------
		.$form->getOpenCombo($lang->def('_WHERE_SHOW_COURSE'))
		.$form->getRadio($lang->def('_SC_EVERYWHERE'), 'course_show_rules_every', 'course_show_rules', '0', 
			($course['show_rules'] == 0) )
		.$form->getRadio($lang->def('_SC_ONLY_IN'), 'course_show_rules_only_in', 'course_show_rules', '1', 
			($course['show_rules'] == 1))
		.$form->getRadio($lang->def('_SC_ONLYINSC_USER'), 'course_show_rules_onlyinsc_user', 'course_show_rules', '2', 
			($course['show_rules'] == 2))
		.$form->getCloseCombo()
		
		//-what-show------------------------------------------------------
		.$form->getOpenCombo($lang->def('_WHAT_SHOW'))
		.$form->getCheckbox($lang->def('_SHOW_PROGRESS'), 'course_progress', 'course_progress', '1', 
			$course['show_progress'] )
		.$form->getCheckbox($lang->def('_SHOW_TIME'), 'course_time', 'course_time', '1', 
			$course['show_time'] )
		.$form->getCheckbox($lang->def('_SHOW_ADVANCED_INFO'), 'course_advanced', 'course_advanced', '1',
			$course['show_extra_info'] )
		.$form->getCloseCombo()
		
		.$form->getCloseFieldset());
	
	//-user-interaction--------------------------------------------------
	$out->add(
		$form->getOpenFieldset($lang->def('_USER_INTERACTION_OPTION'))
		
		//-subscribe-method-----------------------------------------------
		.$form->getOpenCombo($lang->def('_COURSE_SUBSRIBE'))
		.$form->getRadio($lang->def('_COURSE_S_GODADMIN'), 'course_subs_godadmin', 'course_subs', '0', 
			($course['subscribe_method'] == 0) )
		.$form->getRadio($lang->def('_COURSE_S_MODERATE'), 'course_subs_moderate', 'course_subs', '1', 
			($course['subscribe_method'] == 1))
		.$form->getRadio($lang->def('_COURSE_S_FREE'), 'course_subs_free', 'course_subs', '2', 
			($course['subscribe_method'] == 2))
		.$form->getCloseCombo()
		
		//mode for course end---------------------------------------------
		.$form->getOpenCombo($lang->def('_COURSE_END_MODE'))
		.$form->getRadio($lang->def('_COURSE_EM_TEACHER'), 'course_em_manual', 'course_em', '1', 
			$course['permCloseLO'] )
		.$form->getRadio($lang->def('_COURSE_EM_LO'), 'course_em_lo', 'course_em', '0', 
			!$course['permCloseLO'])
		.$form->getCloseCombo()
		
		//status that can enter------------------------------------------
		.$form->getOpenCombo($lang->def('_COURSE_STATUS_CANNOT_ENTER'))
		
		.$form->getCheckbox($lang->def('_USER_STATUS_ISCR'), 'user_status_'._CUS_SUBSCRIBED, 'user_status['._CUS_SUBSCRIBED.']', 
			_CUS_SUBSCRIBED, statusNoEnter($course['userStatusOp'], _CUS_SUBSCRIBED))
		.$form->getCheckbox($lang->def('_USER_STATUS_BEGIN'), 'user_status_'._CUS_BEGIN, 'user_status['._CUS_BEGIN.']', 
			_CUS_BEGIN, statusNoEnter($course['userStatusOp'], _CUS_BEGIN))
		.$form->getCheckbox($lang->def('_USER_STATUS_END'), 'user_status_'._CUS_END, 'user_status['._CUS_END.']', 
			_CUS_END, statusNoEnter($course['userStatusOp'], _CUS_END))
		.$form->getCheckbox($lang->def('_USER_STATUS_SUSPEND'), 'user_status_'._CUS_SUSPEND, 'user_status['._CUS_SUSPEND.']', 
			_CUS_SUSPEND, statusNoEnter($course['userStatusOp'], _CUS_SUSPEND))
		
		.$form->getCloseCombo()
				
		// max number of user that can be subscribed
		.$form->getTextfield($lang->def('_MAX_NUM_SUBSCRIBE'), 'max_num_subscribe', 'max_num_subscribe', 11, $course['max_num_subscribe'])
		
		// sms budget
		.$form->getTextfield($lang->def('_MAX_SMS_BUDGET'), 'max_sms_budget', 'max_sms_budget', 11, $course['max_sms_budget'])
		
		.$form->getCloseFieldset());
	
	//-expiration---------------------------------------------------------
	$out->add(
		$form->getOpenFieldset($lang->def('_COURSE_TIME_OPTION'))
		.$form->getDatefield($lang->def('_DATE_BEGIN'), 'course_date_begin', 'course_date_begin', 
			$GLOBALS['regset']->databaseToRegional($course['date_begin'], 'date'))
		.$form->getDatefield($lang->def('_DATE_END'), 'course_date_end', 'course_date_end', 
			$GLOBALS['regset']->databaseToRegional($course['date_end'], 'date'))
		.$form->getTextfield($lang->def('_DAY_OF_VALIDITY'), 'course_day_of', 'course_day_of', '10', 
			$course['valid_time'])
		.$form->getTextfield($lang->def('_MEDIUM_TIME'), 'course_medium_time', 'course_medium_time', '10', '0', 
			$course['mediumTime'])
		.$form->getCloseFieldset());
	
	$out->add(
		$form->getOpenFieldset($lang->def('_COURSE_SELL_OPTION'))
		.$form->getCheckbox($lang->def('_SELLING'), 'course_selling', 'course_selling', '1', $course['selling'] == 1)
		.$form->getTextfield($lang->def('_PRIZE'), 'course_prize', 'course_prize', '10', $course['prize'])
		.$form->getCloseFieldset());
	
	//sponsor-and-logo----------------------------------------------------
	$out->add(
		$form->getTextfield($lang->def('_SPONSOR_LINK'), 'course_sponsor_link', 'course_sponsor_link', '255', 
			$course['linkSponsor'])
		.$form->getFilefield($lang->def('_SPONSOR_LOGO'), 'course_sponsor_logo', 'course_sponsor_logo')
		.$form->getFilefield($lang->def('_COURSE_LOGO'), 'course_logo', 'course_logo'));
	
	$out->add(
		$form->closeElementSpace()
		.$form->openButtonSpace()
			.$form->getButton('upd_course', 'upd_course', $lang->def('_SAVE'))
			.$form->getButton('course_undo', 'course_undo', $lang->def('_UNDO'))
		.$form->closeButtonSpace());
	
	$out->add($form->closeForm()
		.'</div>');
}

function courseUpdate() {
	require_once($GLOBALS['where_framework'].'/lib/lib.upload.php');
	require_once($GLOBALS['where_lms'].'/lib/lib.course.php');
	
	$array_lang = $GLOBALS['globLangManager']->getAllLangCode();
	
	$path = '/doceboLms/'.$GLOBALS['lms']['pathcourse'];
	if(substr($path, -1) != '/' && substr($path, -1) != '\\') {
		$path = $path.'/';
	}
	
	$id_course = importVar('id_course', true, 0);
	$query_course = "
	SELECT imgSponsor, img_course 
	FROM ".$GLOBALS['prefix_lms']."_course
	WHERE idCourse = '".$id_course."'";
	list($old_sponsor, $old_logo) = mysql_fetch_row(mysql_query($query_course));
	
	$user_status = 0;
	if(isset($_POST['user_status'])) {
		while(list($status) = each($_POST['user_status'])) {
			$user_status |= (1 << $status);
		}
	}
	$file_sponsor = '';
	$file_logo = '';
	$error = 0;
	$show_level = 0;
	if(isset($_POST['course_show_level'])) {
		while(list($lv) = each($_POST['course_show_level'])) {
			$show_level |= (1 << $lv);
		}
	}
	sl_open_fileoperations();
	require_once($GLOBALS['where_framework'].'/lib/lib.multimedia.php');
	if(isset($_FILES['course_sponsor_logo']['tmp_name']) && $_FILES['course_sponsor_logo']['tmp_name'] != '') {
		
		$file_sponsor = 'sponsor_'.mt_rand(0, 100).'_'.time().'_'.$_FILES['course_sponsor_logo']['name'];
		$re = createImageFromTmp($_FILES['course_sponsor_logo']['tmp_name'], 
							$path.$file_sponsor, 
							$_FILES['course_sponsor_logo']['name'],
							150,
							150,
							true );
		
		if($re != 0) {
			$error = 1;
			$file_sponsor = '';
		}
	}
	if(isset($_FILES['course_logo']['tmp_name']) && $_FILES['course_logo']['tmp_name'] != '') {
		
		$file_logo = 'logo_'.mt_rand(0, 100).'_'.time().'_'.$_FILES['course_logo']['name'];
		$re = createImageFromTmp($_FILES['course_logo']['tmp_name'], 
							$path.$file_logo, 
							$_FILES['course_logo']['name'],
							150,
							150,
							true );
		if($re != 0) {
			$error = 1;
			$file_logo = '';
		}
	}
	sl_close_fileoperations();
	
	$query_course = "
	UPDATE ".$GLOBALS['prefix_lms']."_course 
	SET code = '".$_POST['course_code']."', 
		name = '".$_POST['course_name']."', 
		description = '".$_POST['course_descr']."', 
		lang_code = '".$array_lang[$_POST['course_lang']]."', 
		status = '".(int)$_POST['course_status']."', 
		level_show_user = '".$show_level."', 
		subscribe_method = '".(int)$_POST['course_subs']."', 
		linkSponsor = '".$_POST['course_sponsor_link']."', 
		imgSponsor = '".$file_sponsor."', 
		img_course = '".$file_logo."', 
		mediumTime = '".$_POST['course_medium_time']."', 
		permCloseLO = '".$_POST['course_em']."', 
		userStatusOp = '".$user_status."', 
		difficult = '".$_POST['course_difficult']."', 
		show_progress = '".( isset($_POST['course_progress']) ? 1 : 0 )."', 
		show_time = '".( isset($_POST['course_time']) ? 1 : 0 )."', 
		show_extra_info = '".( isset($_POST['course_advanced']) ? 1 : 0 )."', 
		show_rules = '".(int)$_POST['course_show_rules']."', 
		date_begin = '".$GLOBALS['regset']->regionalToDatabase($_POST['course_date_begin'], 'date')."', 
		date_end = '".$GLOBALS['regset']->regionalToDatabase($_POST['course_date_end'], 'date')."', 
		valid_time = '".(int)$_POST['course_day_of']."',
		max_num_subscribe = '".(int)$_POST['max_num_subscribe']."', 
		max_sms_budget = '".$_POST['max_sms_budget']."',
		prize = '".(int)$_POST['course_prize']."',
		selling = '".( isset($_POST['course_selling']) ? 1 : 0 )."'
	WHERE idCourse = '".$id_course."'";
	if(!mysql_query($query_course)) {
		
		echo doDebug($query_course);
		$error = 1;
		if($file_sponsor != '') sl_unlink($path.$file_sponsor);
		if($file_logo != '') sl_unlink($path.$file_logo);
	}
	jumpTo('index.php?modname=course&op=course_list&course_category_status='.importVar('course_category_status')
		.'&error='.$error);
}

function courseDelete() {
	
	if(isset($_POST['confirm_del_course'])) {
		
		$is_ok = removeCourse($_POST['id_course']);
		
		jumpTo('index.php?modname=course&op=course_list&course_category_status='.importVar('course_category_status')
			.'&error='.( $is_ok ? 0 : 1 ));
	} else {
		require_once($GLOBALS['where_framework'].'/lib/lib.lang.php');
		require_once($GLOBALS['where_framework'].'/lib/lib.form.php');
		$lang 		=& DoceboLanguage::CreateInstance('admin_course_managment', 'lms');
		$out 		=& $GLOBALS['page'];
		
		list($id_course) = each($_POST['del_course']);
		$query_course = "
		SELECT code, name 
		FROM ".$GLOBALS['prefix_lms']."_course
		WHERE idCourse = '".$id_course."'";
		list($code, $name) = mysql_fetch_row(mysql_query($query_course));
		
		$out->add(
			getTitleArea($lang->def('_COURSE'), 'course')
			.'<div class="std_block">'
			.Form::openForm('course_del', 'index.php?modname=course&amp;op=del_course')
			.Form::getHidden('id_course', 'id_course', $id_course)
			.getDeleteUi(	$lang->def('_AREYOUSURE'), 
							'<span class="text_bold">'.$lang->def('_COURSE_CODE').' : </span>'.$code.'<br />'
							.'<span class="text_bold">'.$lang->def('_COURSE_NAME').' : </span>'.$name,
							false, 
							'confirm_del_course['.$id_course.']',
							'course_undo')
			.Form::closeForm()
			.'</div>', 'content' );
	}
}

function removeCourse($id_course) {
	
	require_once($GLOBALS['where_lms'].'/lib/lib.course.php');
	
	$acl_man	=& $GLOBALS['current_user']->getAclManager();
	$course_man = new Man_Course();
	
	/*
	//remove advice--------------------------------------------------
	$re_advice = mysql_query("SELECT idAdvice
	FROM ".$GLOBALS['prefix_lms']."_advice
	WHERE idCourse='".$idCourse."'" );
	while( list($id_a) = mysql_fetch_row($re_advice) ) {
		if(!mysql_query("DELETE FROM ".$GLOBALS['prefix_lms']."_adviceuser WHERE idAdvice='".$id_a."'")) return false;
	}
	mysql_free_result($re_advice);
	if(!mysql_query("DELETE FROM ".$GLOBALS['prefix_lms']."_advice WHERE idCourse='".$idCourse."'")) return false;
	
	//remove forum---------------------------------------------------
	$re_forum = mysql_query("
	SELECT idForum 
	FROM ".$GLOBALS['prefix_lms']."_forum 
	WHERE idCourse='".$idCourse."'" );
	while( list($id_f) = mysql_fetch_row($re_forum) ) {
		//thread
		if(!mysql_query("DELETE FROM ".$GLOBALS['prefix_lms']."_forumthread WHERE idForum='".$id_f."'")) return false;
		//access
		if(!mysql_query("DELETE FROM ".$GLOBALS['prefix_lms']."_forum_access WHERE idForum='".$id_f."'")) return false;
	}
	mysql_free_result($re_forum);
		//message
	if(!mysql_query("DELETE FROM ".$GLOBALS['prefix_lms']."_forummessage WHERE idCourse='".$idCourse."'")) return false;
		//sema
	if(!mysql_query("DELETE FROM ".$GLOBALS['prefix_lms']."_forum_sema WHERE idc='".$idCourse."'")) return false;
		//last access
	if(!mysql_query("DELETE FROM ".$GLOBALS['prefix_lms']."_forum_timing WHERE idCourse='".$idCourse."'")) return false;
		//forum
	if(!mysql_query("DELETE FROM ".$GLOBALS['prefix_lms']."_forum WHERE idCourse='".$idCourse."'")) return false;
	
	//remove groups--------------------------------------------------
	$re_group = mysql_query("
	SELECT idGroup 
	FROM ".$GLOBALS['prefix_lms']."_coursegroup 
	WHERE idCourse='".$idCourse."'" );
	while( list($id_g) = mysql_fetch_row($re_group) ) {
		
		if(!mysql_query("DELETE FROM ".$GLOBALS['prefix_lms']."_coursegroupuser WHERE idGroup='".$id_g."'")) return false;
	}
	mysql_free_result($re_group);
	if(!mysql_query("DELETE FROM ".$GLOBALS['prefix_lms']."_coursegroup WHERE idCourse='".$idCourse."'")) return false;
	
	//delete tree
	require_once( 'modules/organization/orglib.php' );
	$tree_course = new OrgDirDb( $idCourse );
	if( !$tree_course->deleteAllTree() ) return false;
	
	//remove inscription---------------------------------------------
	if(!mysql_query("DELETE FROM ".$GLOBALS['prefix_lms']."_courseuser WHERE idCourse = '$idCourse'")) return false;
	
	//remove menu----------------------------------------------------
	if(!mysql_query("DELETE FROM ".$GLOBALS['prefix_lms']."_menucourseunder_custom WHERE idCourse = '$idCourse'")) return false;
	if(!mysql_query("DELETE FROM ".$GLOBALS['prefix_lms']."_menucourse_category WHERE idCourse = '$idCourse'")) return false;
	
	//remove tracking------------------------------------------------
	if(!mysql_query("DELETE FROM ".$GLOBALS['prefix_lms']."_trackingeneral WHERE idCourse = '$idCourse'")) return false;
	if(!mysql_query("DELETE FROM ".$GLOBALS['prefix_lms']."_tracksession WHERE idCourse = '$idCourse'")) return false;
	
	//remove from path-------------------------------------------------
	if(!mysql_query("DELETE FROM ".$GLOBALS['prefix_lms']."_course_path_course WHERE idCourse = '".$idCourse."'")) return false;
	*/
	
	//remove course subscribed------------------------------------------
	
	$levels =& $course_man->getCourseIdstGroupLevel($id_course);
	foreach($levels as $lv => $idst) {
		
		$acl_man->deleteGroup($idst);
	}
	$alluser = getIDGroupAlluser($id_course);
	$acl_man->deleteGroup($alluser);
	$course_man->removeCourseRole($id_course);
	$course_man->removeCourseMenu($id_course);
	
	if(!mysql_query("
	DELETE FROM ".$GLOBALS['prefix_lms']."_courseuser 
	WHERE idCourse = '$id_course'")) return false;
	
	//remove course-----------------------------------------------------
	
	$query_course = "
	SELECT imgSponsor, img_course 
	FROM ".$GLOBALS['prefix_lms']."_course
	WHERE idCourse = '".$id_course."'";
	list($old_sponsor, $old_logo) = mysql_fetch_row(mysql_query($query_course));
	
	require_once($GLOBALS['where_framework'].'/lib/lib.upload.php');
	require_once($GLOBALS['where_lms'].'/setting.php');
	
	$path = '/doceboLms/'.$GLOBALS['lms']['pathcourse'];
	if(substr($path, -1) != '/' && substr($path, -1) != '\\') {
		$path = $path.'/';
	}
	
	sl_open_fileoperations();
	if($old_sponsor != '')
		if(!sl_unlink($path.$old_sponsor)) return false;
	if($old_logo != '')
		if(!sl_unlink($path.$old_logo)) return false;
	sl_close_fileoperations();
	
	if(!mysql_query("DELETE FROM ".$GLOBALS['prefix_lms']."_course WHERE idCourse = '$id_course'")) return false;
	
	//if the scs exist create a room
	if($GLOBALS['where_scs'] !== false) {
	
		require_once($GLOBALS['where_scs'].'/lib/lib.room.php');
		
		$re = deleteRoom(false, 'course', $id_course);
	}
	
	return true;
}

function assignMenu() {
	checkPerm('mod');
	
	require_once($GLOBALS['where_framework'].'/lib/lib.form.php');
	
	if(isset($_POST['assign'])) {
		
		$id_course = importVar('id_course', true, 0);
		$id_custom = importVar('selected_menu', true, 0);
		
		require_once($GLOBALS['where_lms'].'/lib/lib.manmenu.php');
		require_once($GLOBALS['where_lms'].'/lib/lib.course.php');
	
		$acl_man	=& $GLOBALS['current_user']->getAclManager();
		$course_man = new Man_Course();
	
		$levels =& $course_man->getCourseIdstGroupLevel($id_course);
		$course_man->removeCourseRole($id_course);
		$course_man->removeCourseMenu($id_course);
		$course_idst =& $course_man->getCourseIdstGroupLevel($id_course);
		
		$result = cerateCourseMenuFromCustom($id_custom, $id_course, $course_idst);
		
		jumpTo('index.php?modname=course&op=course_list&error='.( $result ? 0 : 1 ));
		
	} else {
		
		$lang =& DoceboLanguage::CreateInstance('admin_course_managment', 'lms');
		
		list($id_course) = each($_POST['assign_menu_course']);
		require_once($GLOBALS['where_framework'].'/lib/lib.form.php');
		
		require_once($GLOBALS['where_lms'].'/admin/modules/category/category.php');
		require_once($GLOBALS['where_lms'].'/admin/modules/category/tree.category.php');
		require_once($GLOBALS['where_lms'].'/lib/lib.manmenu.php');
		require_once($GLOBALS['where_framework'].'/lib/lib.sessionsave.php');
		
		$form = new Form();
		$menu_custom = getAllCustom();
		$sel_custom = key($menu_custom);
		reset($menu_custom);
		
		$GLOBALS['page']->setWorkingZone('content');
		$GLOBALS['page']->add(
			getTitleArea(array($lang->def('_COURSE'), $lang->def('_ASSIGN_MENU')), 'course')
			.'<div class="std_block">'

			.$form->openForm('course_creation', 'index.php?modname=course&amp;op=assignMenu')
			.$form->openElementSpace()
			.$form->getHidden('id_course', 'id_course', $id_course)
			.$form->getDropdown($lang->def('_COURSE_MENU_TO_ASSIGN'), 'selected_menu', 'selected_menu', $menu_custom, 
				$sel_custom )
			
			.$form->closeElementSpace()
			
			.$form->openButtonSpace()
				.$form->getButton('assign', 'assign', $lang->def('_ASSIGN'))
				.$form->getButton('undo', 'undo', $lang->def('_UNDO'))
			.$form->closeButtonSpace()
			.$form->closeForm()
			.'</div>');
	}
}

function move_course() {
	checkPerm('mod');
	
	require_once($GLOBALS['where_lms'].'/admin/modules/category/category.php');
	require_once($GLOBALS['where_lms'].'/admin/modules/category/tree.category.php');
	require_once($GLOBALS['where_framework'].'/lib/lib.sessionsave.php');
	
	$out=& $GLOBALS['page'];
	$lang=& DoceboLanguage::createInstance('admin_course_managment', 'lms');

	$out->add(getTitleArea(array($lang->def('_COURSE'), $lang->def('_MOVECOURSE')), 'course')
		.'<div class="std_block">');

	if( isset($_POST["move_course"]) )
		list($id_course) = each($_POST['move_course']);
	else
		$id_course = importVar('id_course', true, 0);
	
	$categoryDb = new TreeDb_CatDb($GLOBALS['prefix_lms'].'_category');
	$treeView = new TreeView_CatView($categoryDb, 'course_category', $lang->def('_COURSE_CATEGORY'));
	
	$treeView->parsePositionData($_POST, $_POST, $_POST);
	
	$treeView->show_action = false;
	
	if( isset($_POST[$treeView->_getFolderNameId()]) )
		$folderid = $_POST[$treeView->_getFolderNameId()];
	else
		$folderid = $treeView->getSelectedFolderId();

	$folder = $treeView->tdb->getFolderById( $treeView->getSelectedFolderId() );
	$out->add('<form method="post" action="index.php?modname=course&amp;op=move_course">'
		.'<input type="hidden" id="id_course" name="id_course" value="'.$id_course.'" />'
		.'<input type="hidden" id="folderid" name="'.$treeView->_getFolderNameId().'" value="'.$folderid.'" />');
	$out->add('<input type="hidden" name="folder_id" value="'.$treeView->getSelectedFolderId().'" />');
	$out->add('<input type="hidden" name="id_course" value="'.$id_course.'" />');
	$out->add('<div>'.$treeView->getFolderPrintName($folder).'</div>');
	$out->add($treeView->load());
	$out->add(' <img src="'.$treeView->_getMoveImage().'" alt="'.$treeView->_getMoveAlt().'" /> '
		.'<input type="submit" class="TreeViewAction" value="'.$lang->def("_MOVECOURSE").'"'
		.' name="move_course_here" id="move'.$id_course.'" />');
	$out->add(' <img src="'.$treeView->_getCancelImage().'" alt="'.$treeView->_getCancelAlt().'" /> '
		.'<input type="submit" class="TreeViewAction" value="'.$treeView->_getCancelLabel().'"'
		.' name="'.$treeView->_getCancelId().'" id="'.$treeView->_getCancelId().'" />');

	$out->add('</form>'
		.'</div>');
}

function move_course_upd() {
	checkPerm('mod');
	
	require_once($GLOBALS['where_lms'].'/admin/modules/category/category.php');
	require_once($GLOBALS['where_lms'].'/admin/modules/category/tree.category.php');
	require_once($GLOBALS['where_framework'].'/lib/lib.sessionsave.php');
	
	$id_course = importVar('id_course', true, 0);
	
	$categoryDb = new TreeDb_CatDb($GLOBALS['prefix_lms'].'_category');
	$treeView = new TreeView_CatView($categoryDb, 'course_category', '');
	$treeView->parsePositionData($_POST, $_POST, $_POST);
	
	$error = 0;
	$query_course = "
	UPDATE ".$GLOBALS['prefix_lms']."_course 
	SET idCategory = '".$treeView->getSelectedFolderId()."'
	WHERE idCourse = '".$id_course."'";
	if(!mysql_query($query_course)) {
		
		$error = 1;
	}
	jumpTo('index.php?modname=course&op=course_list&course_category_status='.importVar('course_category_status')
		.'&error='.$error);
}

function courseDispatch($op) {

	if(isset($_POST['new_course'])) $op = 'new_course';
	if(isset($_POST['mod_course'])) $op = 'mod_course';
	if(isset($_POST['del_course'])) $op = 'del_course';
	if(isset($_POST['course_undo'])) $op = 'course_list';
	
	if(isset($_POST['assign_menu_course'])) $op = 'assignMenu';
	if(isset($_POST['move_course'])) $op = 'move_course';
	
	if(isset($_POST['move_course_here'])) $op = 'move_course_upd';
	
	if(isset($_POST['undo'])) $op = 'course_list';
	
	switch($op) {
		case "course_list" : {
			course();
		};break;
		
		case "new_course" : {
			addCourse();
		};break;
		case "add_course" : {
			insCourse();
		};break;
		
		case "mod_course" : {
			modCourse();
		};break;
		case "upd_course" : {
			courseUpdate();
		};break;
		
		case "move_course" : {
			move_course();
		};break;
		case "move_course_upd" : {
			move_course_upd();
		};break;
		
		case "del_course" : {
			courseDelete();
		};break;
		
		case "assignMenu" : {
			assignMenu();
		};break;
	}
}

?>