<?php

/************************************************************************/
/* DOCEBO LMS - Learning managment system									*/
/* ============================================							*/
/*																			*/
/* Copyright (c) 2005														*/
/* http://www.docebo.com													*/
/*																			*/
/* This program is free software. You can redistribute it and/or modify	*/
/* it under the terms of the GNU General Public License as published by	*/
/* the Free Software Foundation; either version 2 of the License.		*/
/************************************************************************/

/**
 * @version  $Id: class.report_user.php 113 2006-03-08 18:08:42Z ema $
 * @author	 Fabio Pirovano <fabio [at] docebo [dot] com>
 */

require_once($GLOBALS['where_lms'].'/admin/modules/report/class.report.php');
require_once($GLOBALS['where_lms'].'/lib/lib.course.php');

class Report_User extends Report {
	
	var $lang;
	
	function Report_User($id_report) {
		$this->lang =& DoceboLanguage::createInstance('ru_report');
		parent::Report($id_report);
	}
	
	function play($jump_url, $back_url) {
		
		$lang =& DoceboLanguage::createInstance('report');
		
		$page_title = getTitleArea(array(
			str_replace('&', '&amp;', $back_url) => $lang->def('_REPORT'),
			$this->report_name
		), 'report', $lang->def('_ALT_REPORT'));
		
		// choose the action to perform
		if(isset($_POST['cancelselector'])) {
			
			jumpTo($back_url);
		} elseif(isset($_POST['okselector'])) {
			
			$GLOBALS['page']->add(
				$page_title
				.'<div class="std_block">'
				.getBackUi(str_replace('&', '&amp;', $back_url), $lang->def('_BACK')), 'content');
			$this->show_report($jump_url);
			$GLOBALS['page']->add('</div>', 'content');
		} elseif(isset($_POST['export_cvs'])) {
			
			$this->exportAsCvs();
			
		} else {
			
			// first step load selector 
			require_once($GLOBALS['where_framework'].'/class.module/class.directory.php');
			
			$aclManager = new DoceboACLManager();
			$user_select = new Module_Directory();
			
			$user_select->show_user_selector = TRUE;
			$user_select->show_group_selector = TRUE;
			$user_select->show_orgchart_selector = TRUE;
			$user_select->show_orgchart_simple_selector = FALSE;
			$user_select->multi_choice = TRUE;
			
			$user_select->setPageTitle($page_title);
			$user_select->loadSelector(str_replace('&', '&amp;', $jump_url), 
					false, 
					$lang->def('_CHOOSE_USER_FOR_REPORT'), 
					true, 
					true );
			
		}
	}
	
	
	function _converStatusCourse($status) {
		switch($status) {
			case "0" : return $this->lang->def('_NOACTIVE');
			case "1" : return $this->lang->def('_ACTIVE');
			case "2" : return $this->lang->def('_DEACTIVE');
		}
	}
	
	// XXX: convertStatusUser($status)
	
	function _convertStatusUser($status) {
		switch($status) {
			case _CUS_SUBSCRIBED : return $this->lang->def('_INSCR_STATUS');
			case _CUS_BEGIN : return $this->lang->def('_BEGIN');
			case _CUS_END : return $this->lang->def('_END');
			case _CUS_SUSPEND : return $this->lang->def('_SUSPEND');
		}
	}
	
	function show_report($jump_url) {
		
		require_once($GLOBALS['where_framework'].'/lib/lib.form.php');
		require_once($GLOBALS['where_framework'].'/class.module/class.directory.php');
		require_once($GLOBALS['where_lms'].'/lib/lib.course.php');
		
		$GLOBALS['page']->add(
			"\n".'<link href="'.getPathTemplate('lms').'style/report/style_report_user.css" rel="stylesheet" type="text/css" />'."\n"
		, 'page_head');
		
		$lang =& DoceboLanguage::createInstance('ru_report');
		
		$acl_man 		= new DoceboACLManager();
		$course_man 	= new Man_Course();
		
		$user_select 	= new Module_Directory();
		$elem_selected 	= $user_select->getSelection($_POST);
		$user_selected 	=& $acl_man->getAllUsersFromIdst($elem_selected);
		
		if(empty($user_selected)) {
			
			$GLOBALS['page']->add($lang->def('_NULL_SELECTION'), 'content');
			return;
		}
		$users_info =& $acl_man->getUsers($user_selected);
		
		// Retrive all the course
		$id_courses = $course_man->getAllCourses();
		if(empty($id_courses)) {
			
			$GLOBALS['page']->add($lang->def('_NULL_COURSE_SELECTION'), 'content');
			return;
		}
		
		$re_category = mysql_query("
		SELECT idCategory, path 
		FROM ".$GLOBALS['prefix_lms']."_category");
		$category_list = array(0 => $lang->def('_ROOT_CATEGORY'));
		while(list($id_cat, $name_cat) = mysql_fetch_row($re_category)) {
			$category_list[$id_cat] = substr($name_cat, strrpos($name_cat, '/') + 1 );
		}
		
		$time_list = array();
		$session_list = array();
		$lastaccess_list = array();
		$re_time = mysql_query("
		SELECT idUser, idCourse, COUNT(*), SUM(UNIX_TIMESTAMP(lastTime) - UNIX_TIMESTAMP(enterTime)), MAX(lastTime) 
		FROM ".$GLOBALS['prefix_lms']."_tracksession 
		GROUP BY idUser, idCourse ");
		while(list($id_u, $id_c, $session_num, $time_num, $last_num) = mysql_fetch_row($re_time)) {
			
			$session_list[$id_u.'_'.$id_c] 	= $session_num;
			$time_list[$id_u.'_'.$id_c] 		= $time_num;
			$lastaccess_list[$id_u.'_'.$id_c] 	= $last_num;
		}
		
		// Export as cvs
		$GLOBALS['page']->add(
			Form::openForm('export', $jump_url)
			.Form::openElementSpace('text_withborder')
			.Form::getHidden('user_selected', 'user_selected', urlencode(serialize($user_selected)))
			.form::getButton('export_cvs', 'export_cvs', $lang->def('_CSVEXPORT'), 'export_cvs')
			.Form::closeElementSpace()
			.Form::closeForm()
		, 'content');
		
		// Table
		$GLOBALS['page']->add(
			'<table class="report_table" summary="'.$lang->def('_RU_SUMMAMRY_MANAGMENT').'">'
			.'<caption>'.$lang->def('_RU_CAPTION').'</caption>'
			.'<thead>'
			.'<tr>'."\n\t"
				.'<th colspan="2">'.$lang->def('_TH_USER').'</th>'."\n\t"
				.'<th colspan="4">'.$lang->def('_TH_COURSE').'</th>'."\n\t"
				.'<th colspan="7">'.$lang->def('_TH_STATUS').'</th>'."\n"
			.'</tr>'
			.'<tr>'."\n\t"
				.'<th>'.$lang->def('_TH_USERCODE').'</th>'."\n\t"
				.'<th>'.$lang->def('_TH_USERNAME').'</th>'."\n\t"
				.'<th>'.$lang->def('_TH_COURSEID').'</th>'."\n\t"
				.'<th>'.$lang->def('_TH_CAT').'</th>'."\n\t"
				.'<th>'.$lang->def('_TH_COURSENAME').'</th>'."\n\t"
				.'<th>'.$lang->def('_TH_COURSESTATUS').'</th>'."\n\t"
		
				.'<th>'.$lang->def('_TH_USER_INSCRIPTION_DATE').'</th>'."\n\t"
				.'<th>'.$lang->def('_TH_USER_START_DATE').'</th>'."\n\t"
				.'<th>'.$lang->def('_TH_USER_END_DATE').'</th>'."\n\t"
				.'<th>'.$lang->def('_TH_LAST_ACCESS_DATE').'</th>'."\n\t"
				.'<th>'.$lang->def('_TH_USER_STATUS').'</th>'."\n\t"
				.'<th class="image">'.$lang->def('_TH_USER_NUMBER_SESSION').'</th>'."\n\t"
				.'<th class="image">'.$lang->def('_TH_USER_ELAPSED_TIME').'</th>'."\n"
			.'</tr>'
			.'<thead>'."\n\n"
			.'<tbody>'
		, 'content');
		
		// find some information
		$query_course_user = "
		SELECT cu.idUser, 
			c.idCourse, c.idCategory, c.name, c.status,
			cu.status, cu.date_inscr, cu.date_first_access, cu.date_complete
		FROM  ".$GLOBALS['prefix_lms']."_courseuser AS cu 
			JOIN ".$GLOBALS['prefix_lms']."_course AS c
		WHERE cu.idCourse = c.idCourse AND cu.idUser IN ( ".implode(',', $user_selected)." )";
		$re_course_user = mysql_query($query_course_user);
		$i = 0;
		while(list($id_user, $id_course, $id_category, $name, $status,
			$status_user, $date_inscr, $date_first_access, $date_complete) =  mysql_fetch_row($re_course_user) ) {
			
			$username = ( $users_info[$id_user][ACL_INFO_LASTNAME].$users_info[$id_user][ACL_INFO_FIRSTNAME]
				? $users_info[$id_user][ACL_INFO_LASTNAME].' '.$users_info[$id_user][ACL_INFO_FIRSTNAME]
				: $acl_man->relativeId($users_info[$id_user][ACL_INFO_USERID]) );
			
			$row = '<tr class="row'.( ++$i%2 ? '' : '-col' ).'">'."\n\t"
				.'<td class="align_center">'.$id_user.'</td>'."\n\t"
				.'<td>'.$username.'</td>'."\n\t"
				.'<td class="align_center">'.$id_course.'</td>'."\n\t"
				.'<td>'.$category_list[$id_category].'</td>'."\n\t"
				.'<td>'.$name.'</td>'."\n\t"
				.'<td class="align_center">'.$this->_converStatusCourse($status).'</td>'."\n\t"
				
				.'<td class="align_center">'.$date_inscr.'</td>'."\n\t"
				.'<td class="align_center">'.( $date_first_access !== NULL ? $date_first_access : '&nbsp;').'</td>'."\n\t"
				.'<td class="align_center">'.( $date_complete !== NULL ? $date_complete : '&nbsp;').'</td>'."\n\t"
				.'<td class="align_center">'
					.( isset($lastaccess_list[$id_user.'_'.$id_course]) ? $lastaccess_list[$id_user.'_'.$id_course] : '' )
				.'</td>'."\n\t"
				.'<td class="align_center">'.$this->_convertStatusUser($status_user).'</td>'."\n\t"
				.'<td class="align_center">'
					.( isset($session_list[$id_user.'_'.$id_course]) ? $session_list[$id_user.'_'.$id_course] : '' )
				.'</td>'."\n\t"
				.'<td class="align_center">'
					.( isset($time_list[$id_user.'_'.$id_course]) ? 
					substr('0'.((int)($time_list[$id_user.'_'.$id_course]/3600)),-2).'h '
					.substr('0'.((int)(($time_list[$id_user.'_'.$id_course]%3600)/60)),-2).'m '
					.substr('0'.((int)($time_list[$id_user.'_'.$id_course]%60)),-2).'s ' : '&nbsp;' )
				.'</td>'."\n"
				.'</tr>'."\n\n";
			$GLOBALS['page']->add( $row, 'content');
		}
		$GLOBALS['page']->add( 
			'</tbody>'
			.'</table>', 'content');
	}
	
	function exportAsCvs() {
		
		ob_end_clean();
		//content type forcing dowlad
		header("Content-type: application/download\n");
		//cache control
		header("Cache-control: private");
		//sending creation time
		header('Expires: ' . gmdate('D, d M Y H:i:s') . ' GMT');
		//content type
		header('Content-Disposition: attachment; filename="report_user '.gmdate('d-m-Y H i s').'.csv"');
		
		require_once($GLOBALS['where_framework'].'/class.module/class.directory.php');
		require_once($GLOBALS['where_lms'].'/lib/lib.course.php');
		
		$lang =& DoceboLanguage::createInstance('ru_report');
		
		$acl_man 		= new DoceboACLManager();
		$course_man 	= new Man_Course();
		
		$user_selected = unserialize(urldecode($_POST['user_selected']));
		
		if(empty($user_selected)) {
			
			$GLOBALS['page']->add($lang->def('_NULL_SELECTION'), 'content');
			return;
		}
		if(empty($user_selected)) {
			
			exit();
		}
		$users_info =& $acl_man->getUsers($user_selected);
		
		// Retrive all the course
		$id_courses = $course_man->getAllCourses();
		if(empty($id_courses)) {
			
			exit();
		}
		
		$re_category = mysql_query("
		SELECT idCategory, path 
		FROM ".$GLOBALS['prefix_lms']."_category");
		$category_list = array(0 => $lang->def('_ROOT_CATEGORY'));
		while(list($id_cat, $name_cat) = mysql_fetch_row($re_category)) {
			$category_list[$id_cat] = substr($name_cat, strrpos($name_cat, '/') + 1 );
		}
		
		$time_list = array();
		$session_list = array();
		$lastaccess_list = array();
		$re_time = mysql_query("
		SELECT idUser, idCourse, COUNT(*), SUM(UNIX_TIMESTAMP(lastTime) - UNIX_TIMESTAMP(enterTime)), MAX(lastTime) 
		FROM ".$GLOBALS['prefix_lms']."_tracksession 
		GROUP BY idUser, idCourse ");
		while(list($id_u, $id_c, $session_num, $time_num, $last_num) = mysql_fetch_row($re_time)) {
			
			$session_list[$id_u.'_'.$id_c] 	= $session_num;
			$time_list[$id_u.'_'.$id_c] 		= $time_num;
			$lastaccess_list[$id_u.'_'.$id_c] 	= $last_num;
		}
		
		// Table
		echo $this->report_name."\n"
		.''.$lang->def('_TH_USER').',,'.$lang->def('_TH_COURSE').',,,'.$lang->def('_TH_STATUS').',,,,,,,'."\n"		
		.$lang->def('_TH_USERCODE').','
		.$lang->def('_TH_USERNAME').','
		.$lang->def('_TH_COURSEID').','
		.$lang->def('_TH_CAT').','
		.$lang->def('_TH_COURSENAME').','
		.$lang->def('_TH_COURSESTATUS').','
		.$lang->def('_TH_USER_INSCRIPTION_DATE').','
		.$lang->def('_TH_USER_START_DATE').','
		.$lang->def('_TH_USER_END_DATE').','
		.$lang->def('_TH_LAST_ACCESS_DATE').','
		.$lang->def('_TH_USER_STATUS').','
		.$lang->def('_TH_USER_NUMBER_SESSION').','
		.$lang->def('_TH_USER_ELAPSED_TIME')."\n";
		
		// find some information
		$query_course_user = "
		SELECT cu.idUser, 
			c.idCourse, c.idCategory, c.name, c.status,
			cu.status, cu.date_inscr, cu.date_first_access, cu.date_complete
		FROM  ".$GLOBALS['prefix_lms']."_courseuser AS cu 
			JOIN ".$GLOBALS['prefix_lms']."_course AS c
		WHERE cu.idCourse = c.idCourse AND cu.idUser IN ( ".implode(',', $user_selected)." )";
		$re_course_user = mysql_query($query_course_user);
		$i = 0;
		while(list($id_user, $id_course, $id_category, $name, $status,
			$status_user, $date_inscr, $date_first_access, $date_complete) =  mysql_fetch_row($re_course_user) ) {
			
			$username = ( $users_info[$id_user][ACL_INFO_LASTNAME].$users_info[$id_user][ACL_INFO_FIRSTNAME]
				? $users_info[$id_user][ACL_INFO_LASTNAME].' '.$users_info[$id_user][ACL_INFO_FIRSTNAME]
				: $acl_man->relativeId($users_info[$id_user][ACL_INFO_USERID]) );
			
			echo ''.$id_user.','
				.''.$username.','
				.''.$id_course.','
				.''.$category_list[$id_category].','
				.''.$name.','
				.''.$this->_converStatusCourse($status).','
				.''.$date_inscr.','
				.''.( $date_first_access !== NULL ? $date_first_access : '&nbsp;').','
				.''.( $date_complete !== NULL ? $date_complete : '&nbsp;').','
				.''.( isset($lastaccess_list[$id_user.'_'.$id_course]) ? $lastaccess_list[$id_user.'_'.$id_course] : '' ).','
				.''.$this->_convertStatusUser($status_user).','
				.''.( isset($session_list[$id_user.'_'.$id_course]) ? $session_list[$id_user.'_'.$id_course] : '' ).','
				.( isset($time_list[$id_user.'_'.$id_course]) ? 
					substr('0'.((int)($time_list[$id_user.'_'.$id_course]/3600)),-2).'h '
					.substr('0'.((int)(($time_list[$id_user.'_'.$id_course]%3600)/60)),-2).'m '
					.substr('0'.((int)($time_list[$id_user.'_'.$id_course]%60)),-2).'s ' : '' )
				.''."\n";
		}
		exit();
	}
}

?>