<?php

/************************************************************************/
/* DOCEBO LMS - Learning managment system									*/
/* ============================================							*/
/*																			*/
/* Copyright (c) 2005														*/
/* http://www.docebo.com													*/
/*																			*/
/* This program is free software. You can redistribute it and/or modify	*/
/* it under the terms of the GNU General Public License as published by	*/
/* the Free Software Foundation; either version 2 of the License.		*/
/************************************************************************/

/**
 * @package DoceboLms
 * @subpackage Course managment
 * @author Fabio Pirovano <fabio [at] docebo-com>
 * @version  $Id: lib.course.php 143 2006-03-20 21:24:54Z fabio $
 */

define("_CUS_SUBSCRIBED", 0);
define("_CUS_BEGIN", 1);
define("_CUS_END", 2);
define("_CUS_SUSPEND", 3);

class Selector_Course {
	
	var $treeview = NULL;
	
	var $treeDB = NULL;
	
	var $show_filter = true;
	
	var $filter = array();
	
	var $current_page = array();
	
	var $current_selection = array();
	
	/**
	 * Class constructor
	 */
	function Selector_Course() {
		
		require_once($GLOBALS['where_lms'].'/admin/modules/category/tree.category.php');
		require_once($GLOBALS['where_framework'].'/lib/lib.newtypeone.php');
		require_once($GLOBALS['where_framework'].'/lib/lib.form.php');
		require_once($GLOBALS['where_lms'].'/lib/lib.levels.php');
		
		$lang =& DoceboLanguage::createInstance('admin_course_managment', 'lms');
		
		$this->show_filter = true;
		$this->treeDB 		= new TreeDb_CatDb($GLOBALS['prefix_lms'].'_category');
		$this->treeview 	= new TreeView_CatView($this->treeDB , 'course_category', $lang->def('_COURSE_CATEGORY'));
		$this->treeview->hideInlineAction();
	}
	
	function enableFilter() {
		
		$this->show_filter = true;
	}
	
	function disableFilter() {
		
		$this->show_filter = false;
	}
	
	/**
	 * return the current status in a pratic format
	 * @return string a string with the data used for reloading the current status
	 */
	function getStatus() {
		
		$this->treeview->deRegisterLang();
		$status = array(
			'page' 					=> $this->current_page,
			'filter' 				=> urlencode(serialize($this->filter)), 
			'show_filter' 			=> $this->show_filter, 
			'current_selection' 	=> $this->current_selection, 
			'treeview_status' 		=> urlencode(serialize($this->treeview)) );
		return urlencode(serialize($status));
	}
	
	/**
	 * reset the current status to te given one
	 * @param string	$status_serialized a valid status saved using getStatus
	 */
	function loadStatus(&$status_serialized) {
		
		if($status_serialized == '') return ;
		$status = unserialize(urldecode($status_serialized));
		
		$this->current_page			= $status['page'];
		$this->filter				= unserialize(urldecode($status['filter']));
		$this->show_filter			= $status['show_filter'];
		$this->current_selection	= $status['current_selection'];
		$this->treeview				= unserialize(urldecode($status['treeview_status']));
		$this->treeDB 				=& $this->treeview->getTreeDb();
		$this->treeview->reRegisterLang();
	}
	
	function parseForAction($array_action) {
	
	}
	
	function parseForState($array_state) {
		
		// load change in treeview
		$this->treeview->parsePositionData($array_state, $array_state, $array_state);
		// older selection
		if(isset($array_state['course_selected'])) {
			
			$this->current_selection = unserialize(urldecode($array_state['course_selected']));
		}
		// add last selection
		if(isset($_POST['new_course_selected'])) {
			while(list($id_c) = each($array_state['new_course_selected'])) {
				
				$this->current_selection[$id_c] = $id_c;
			}
		}
	}
	
	function stateSelection() {
		
		return Form::getHidden('course_selected', 'course_selected', urlencode(serialize($this->current_selection)) );
	}
	
	function getSelection() {
		
		return $this->current_selection;
	}
	
	
	function resetSelection($new_selection) {
		
		$this->current_selection = $new_selection;
	}
	
	function loadCourseSelector() {
		
		require_once($GLOBALS['where_framework'].'/lib/lib.newtypeone.php');
		require_once($GLOBALS['where_framework'].'/lib/lib.form.php');
		
		$lang =& DoceboLanguage::createInstance('admin_course_managment', 'lms');
		
		$GLOBALS['page']->add($this->treeview->load(), 'content');
		
		// Filter
		
		$this->filter['course_flat'] = isset($_POST['c_flatview']);
		$this->filter['course_code'] = ( isset($_POST['c_filter_code']) ? $_POST['c_filter_code'] : '' );
		$this->filter['course_name'] = ( isset($_POST['c_filter_name']) ? $_POST['c_filter_name'] : '' );
		if($this->show_filter === true) {
			$form = new Form();
			$GLOBALS['page']->add(
				$form->getOpenFieldset($lang->def('_COURSEFILTER'))
				.Form::getTextfield($lang->def('_FILTER_CODE'), 'c_filter_code', 'c_filter_code', '50', 
					( isset($_POST['c_filter_code']) ? $_POST['c_filter_code'] : '' ))
				.Form::getTextfield($lang->def('_FILTER_NAME'), 'c_filter_name', 'c_filter_name', '255', 
					( isset($_POST['c_filter_name']) ? $_POST['c_filter_name'] : '' ))
				.Form::getCheckbox($lang->def('_FILTER_FLATVIEW'), 'c_flatview', 'c_flatview', '1', 
					$this->filter['course_flat'], 
					' onclick="submit();" ' )
				.$form->openButtonSpace() 
				.$form->getButton('course_filter', 'course_filter', $lang->def('_SEARCH'))
				.$form->closeButtonSpace()
				.$form->getCloseFieldset()
			, 'content');
		}
		// End Filter
		
		$tb = new TypeOne($GLOBALS['lms']['visu_course'], $lang->def('_COURSE_LIST_CAPTION'), $lang->def('_COURSE_LIST_SUMMARY'));
		
		$tb->initNavBar('ini', 'button');
		$ini = $tb->getSelectedElement();
		
		$category_selected 	= $this->treeview->getSelectedFolderId();
		if($this->filter['course_flat']) {
			$id_categories 		= $this->treeDB->getDescendantsId($this->treeDB->getFolderById($category_selected));
			$id_categories[] 	= $category_selected;	
		}
		$select = "
		SELECT c.idCourse, c.code, c.name, c.description, c.status, c.difficult, 
			c.subscribe_method, c.permCloseLo, c.show_rules, c.max_num_subscribe "; 
		$query_course = "
		FROM ".$GLOBALS['prefix_lms']."_course AS c
		WHERE c.idCategory IN ( ".( !$this->filter['course_flat'] ? $category_selected  : implode(",", $id_categories) )." )";
		if($GLOBALS['current_user']->getUserLevelId() != ADMIN_GROUP_GODADMIN) {
		
			require_once($GLOBALS['where_lms'].'/lib/lib.course_managment.php');
			
			$course_man = new AdminCourseManagment();
			$all_courses =& $course_man->getUserAllCourses( getLogUserId() );
			
			if(empty($all_courses)) $query_course .= " AND 0 ";
			else $query_course .= " AND c.idCourse IN (".implode(',', $all_courses).") ";
		}
		if($this->filter['course_code'] != '') {
			$query_course .= " AND c.code LIKE '%".$this->filter['course_code']."%'";
		}
		if($this->filter['course_name'] != '') {
			$query_course .= " AND c.name LIKE '%".$this->filter['course_name']."%'";
		}
		list($tot_course) = mysql_fetch_row(mysql_query("SELECT COUNT(*) ".$query_course));
		$query_course .= " ORDER BY c.name 
							LIMIT ".$ini.",".(int)$GLOBALS['lms']['visu_course'];
		
		$re_course = mysql_query($select.$query_course);
		
		$type_h = array('image', '', '', '');
		$cont_h = array(
			'<span class="access-only">'.$lang->def('_COURSE_SELECTION').'</span>', 
			$lang->def('_COURSE_CODE'), 
			$lang->def('_COURSE_NAME'), 
			$lang->def('_COURSE_STATUS')
		);
		$tb->setColsStyle($type_h);
		$tb->addHead($cont_h);
		while(list($id_course, $code, $name, $desc, $status, $difficult, $auto_sub, $end_mode, $show_rules, $max_user_sub) = mysql_fetch_row($re_course)) {
			
			$tb_content = array(
				Form::getInputCheckbox('new_course_selected_'.$id_course, 'new_course_selected['.$id_course.']', $id_course, 
					isset($this->current_selection[$id_course]), ''), 
				'<label for="new_course_selected_'.$id_course.'">'.$code.'</label>',
				'<label for="new_course_selected_'.$id_course.'">'.$name.'</label>'
			);
			switch($status) {
				case 0 : $tb_content[] = $lang->def('_CST_PRE_DO');break;
				case 1 : $tb_content[] = $lang->def('_CST_IN_DO');break;
				case 2 : $tb_content[] = $lang->def('_CST_AFTER_DO');break;
			}
			$tb->addBody($tb_content);
			if(isset($this->current_selection[$id_course])) unset($this->current_selection[$id_course]);
		}
		
		$GLOBALS['page']->add(
			$tb->getTable()
			.$tb->getNavBar($ini, $tot_course)
			.$this->stateSelection(), 'content');
	}
}

class Man_Course {
	
	function Man_Course() {
	
	}
	
	function saveCourseStatus() {
		require_once($GLOBALS['where_lms'].'/admin/modules/category/tree.category.php');
		require_once($GLOBALS['where_framework'].'/lib/lib.sessionsave.php');
		
		$categoryDb = new TreeDb_CatDb($GLOBALS['prefix_lms'].'_category');
		$treeView = new TreeView_CatView($categoryDb, 'course_category', def('_COURSE_CATEGORY', 'admin_course_managment', 'lms'));
		$treeView->parsePositionData($_POST, $_POST, $_POST);
		
		//save status
		$o_save = new Session_Save();
		$tree_status = $o_save->getName('course_category', true);
		$o_save->save($tree_status, $treeView);
	}
	
	/**
	 * @param int 	$id_course			the id of the course
	 *
	 * @return array	return som info about the course [code, name, description, status, difficult, subscribe_method, max_num_subscribe]
	 */
	function getCourseInfo($id_course) {
		
		$query = "
		SELECT idCategory, code, name, description, status, difficult, subscribe_method, max_num_subscribe, selling, prize 
		FROM ".$GLOBALS['prefix_lms']."_course 
		WHERE idCourse = '".$id_course."'";
		$re = mysql_query($query);
		
		return mysql_fetch_assoc($re);
	}
	
	/**
	 * return the list of all the courses in the platform, or fillter by category
	 * @param int 	$id_category	filter for passed category
	 *
	 * @return array	[id_course] => ( [id_course], [name], [course] )
	 */
	function getAllCourses($id_category = false) {
		
		$courses = array();
		$query_course = "
		SELECT idCourse, code, name
		FROM ".$GLOBALS['prefix_lms']."_course ";
		if($id_category !== false) $query_course .= " WHERE idCategory = '".$id_category."' ";
		$query_course .= " ORDER BY name";
		
		$re_course = mysql_query($query_course);
		while(list($id, $code, $name) = mysql_fetch_row($re_course)) {
			
			$courses[$id] = array(	'id_course' => $id,
									'name' => $name,
									'code' => $code );
		}
		return $courses;
	}
	
	/**
	 * return the list of all the courses in the platform, or fillter by category
	 * @param int 	$id_category	filter for passed category
	 *
	 * @return array	[id_course] => ( idCourse, idCategory, code, name, description, lang_code, status, subscribe_method, mediumTime, selling, prize  )
	 */
	function &getAllCoursesWithMoreInfo($id_category = false) {
		
		$courses = array();
		$query_course = "
		SELECT idCourse, idCategory, code, name, description, lang_code, status, 
			subscribe_method, mediumTime, show_rules, selling, prize 
		FROM ".$GLOBALS['prefix_lms']."_course ";
		if($id_category !== false) $query_course .= " WHERE idCategory = '".$id_category."' ";
		$query_course .= " ORDER BY name";
		$re_course = mysql_query($query_course);
		while($course = mysql_fetch_array($re_course)) {
			
			$courses[$course['idCourse']] = $course;
		}
		return $courses;
	}
	
	/**
	 * @param int 	$id_course			the id of the course
	 *
	 * @return array	contains the info of the waiting usersin [user_info] and all the id_user occurrency in [all_user_id]
	 */
	function &getWaitingSubscribed($id_course) {
		
		$users['users_info'] 	= array();
		$users['all_users_id'] 	= array();
		
		$query_courseuser = "
		SELECT idUser, level, subscribed_by 
		FROM ".$GLOBALS['prefix_lms']."_courseuser 
		WHERE idCourse = '".$id_course."' AND waiting = '1'";
		$re_courseuser = mysql_query($query_courseuser);
		while(list($id_user, $lv, $subscribed_by) = mysql_fetch_row($re_courseuser)) {
			
			$users['users_info'][$id_user] 			= array(
				'id_user' => $id_user,
				'level' => $lv,
				'subscribed_by' => $subscribed_by,
			);
			
			$users['all_users_id'][$id_user] 		= $id_user;
			$users['all_users_id'][$subscribed_by] = $subscribed_by;
		}
		return $users;
	}
	
	/**
	 * Find the idst of the group of a course that represent the level
	 * @param 	int 	$id_course 	the id of the course
	 * 
	 * @return 	array	[lv] => idst, [lv] => idst
	 */
	function &getCourseIdstGroupLevel($id_course) {
		
		$map 		= array();
		$levels 	= CourseLevel::getLevels();
		$acl_man	=& $GLOBALS['current_user']->getAclManager();
		
		
		// find all the group created for this menu custom for permission management
		foreach($levels as $lv => $name_level) {
			
			$group_info = $acl_man->getGroup(FALSE, '/lms/course/'.$id_course.'/subscribed/'.$lv);
			$map[$lv] 	= $group_info[ACL_INFO_IDST];
		}
		/*
		if($also_waiting === true) {
			$group_info = $acl_man->getGroup(FALSE, '/lms/course/'.$id_course.'/subscribed/waiting');
			$map['waiting'] 	= $group_info[ACL_INFO_IDST];
		}*/
		return $map;
	}
	
	function getIdUserOfLevel($id_course, $level_number = false) {
		
		$users = array();
		$query_courseuser = "
		SELECT idUser 
		FROM ".$GLOBALS['prefix_lms']."_courseuser 
		WHERE idCourse = '".$id_course."'";
		if($level_number !== false) $query_courseuser .= " AND level = '".$level_number."'";
		
		$re_courseuser = mysql_query($query_courseuser);
		while(list($id_user) = mysql_fetch_row($re_courseuser)) {
			
			$users[$id_user] = $id_user;
		}
		return $users;
	}
	
	/**
	 * @param int 		$id_course		the id of the course
	 * @param array 	$arr_users		if specified filter the user
	 *
	 * @return array	contains the id_user as key and level number as value
	 */
	function getLevelsOfUsers($id_course, $arr_users = false) {
		
		$id_users 	= array();
		
		$query_courseuser = "
		SELECT idUser, level 
		FROM ".$GLOBALS['prefix_lms']."_courseuser 
		WHERE idCourse = '".$id_course."'";
		if($arr_users !== false) {
			$query_courseuser .= " AND idUser IN ( ".implode(',', $arr_users)." )";
		}
		
		$re_courseuser = mysql_query($query_courseuser);
		while(list($id_user, $lv) = mysql_fetch_row($re_courseuser)) {
			
			$id_users[$id_user] = $lv;
		}
		return $id_users;
	}
	
	function &getModulesName($id_course) {
		
		$ml_lang = DoceboLanguage::createInstance('menu_course');
		$mods_names = array();
		$query_menu = "
		SELECT mo.module_name, mo.default_op, mo.default_name, mo.token_associated, under.my_name 
		FROM ".$GLOBALS['prefix_lms']."_module AS mo JOIN  
			".$GLOBALS['prefix_lms']."_menucourse_under AS under
		WHERE mo.idModule = under.idModule AND under.idCourse = '".$id_course."'";
		$re_menu_voice = mysql_query($query_menu);
		while(list($module_name, $default_op, $default_name, $token, $my_name) = mysql_fetch_row($re_menu_voice)) {
			
			$mods_names[$module_name] = ( ($my_name != '' ) ? $my_name : ( $ml_lang->isDef($default_name) ? $ml_lang->def($default_name) : $default_name ) );
		}
		return $mods_names;
	}
	
	function removeCourseRole($id_course) {
	
		$acl_man =& $GLOBALS['current_user']->getAclManager();
		$base_path = '/lms/course/private/'.$id_course;
		$acl_man->deleteRoleFromPath($base_path);
	}
	
	function removeCourseMenu($id_course) {
		
		$query_del = "
		DELETE FROM ".$GLOBALS['prefix_lms']."_menucourse_main
		WHERE idCourse = '".$id_course."'";
		
		$query_del_voice = "
		DELETE FROM ".$GLOBALS['prefix_lms']."_menucourse_under
		WHERE idCourse = '".$id_course."'";
		
		if(!mysql_query($query_del)) return false;
		if(!mysql_query($query_del_voice)) return false;
	}
	
	function canEnterCourse(&$course) {
		// control if the user is in a status that cannot enter
		$now = time();
		if($course['level'] > 3) return true;
		if(isset($course['prerequisites_satisfied']) && $course['prerequisites_satisfied'] == false) return false;
		if($course['waiting'] == 1) return false;
		// control if the course is elapsed
		if($course['date_begin'] != '0000-00-00') {
			
			$time_begin = fromDatetimeToTimestamp($course['date_begin']);
			
			if($now < $time_begin) return false;
		}
		if($course['date_end'] != '0000-00-00') {
			
			$time_end = fromDatetimeToTimestamp($course['date_end']);
			
			if($now > $time_end) return false;
		}
		if($course['valid_time'] != '0' && $course['valid_time'] != '' && $course['date_first_access'] != '') {
			
			$time_first_access =fromDatetimeToTimestamp($course['date_first_access']);
			
			if($now > ( $time_first_access + ($course['valid_time'] * 24 * 3600 ) )) return false;
		}
		if( $course['userStatusOp'] & (1 << $course['user_status']) ) return false;
		// user is not a tutor or a prof and the course isn't active
		if($course['course_status'] != 1 && $course['level'] < 4) return false;
		return true;
	}
	
	function getNumberOfCoursesForCategories($show_rules  = 0) {
		
		$courses = array();
		$query_course = "
		SELECT idCategory, COUNT(*) 
		FROM ".$GLOBALS['prefix_lms']."_course 
		WHERE show_rules  = '".$show_rules ."'
		GROUP BY idCategory";
		
		$re_course = mysql_query($query_course);
		while(list($id_cat, $number_of_course) = mysql_fetch_row($re_course)) {
			
			$courses[$id_cat] = $number_of_course;
		}
		return $courses;
	}
	
	function &getCategoriesInfo($id_parent, $also_itself = false) {
		
		$categories = array();
		$query_cat = "
		SELECT idCategory, idParent, lev, path, description 
		FROM ".$GLOBALS['prefix_lms']."_category 
		WHERE idParent = '".$id_parent."' ";
		if($also_itself !== false) $query_cat .= " OR idCategory = '".$id_parent."' ";
		$query_cat .= " ORDER BY path ";
		
		$re_category = mysql_query($query_cat);
		while($cat = mysql_fetch_array($re_category)) {
			
			$categories[$cat['idCategory']] = $cat;
			$categories[$cat['idCategory']]['name'] = ( 
				($pos = strrpos($cat['path'], '/')) === FALSE  
					? $cat['path'] 
					: substr($cat['path'], $pos+1) 
			);
		}
		return $categories;
	}
	
	function _recurseCategory($id_cat, &$title_link, $link, $parent_name) {
		
		if(!$id_cat) return '';
		$query_cat = "
		SELECT idParent, lev, path 
		FROM ".$GLOBALS['prefix_lms']."_category 
		WHERE idCategory = '".$id_cat."'";
		if(!$re_category = mysql_query($query_cat)) return '';
		list($id_parent, $lev, $path) = mysql_fetch_row($re_category);
		
		$name = ( ($pos = strrpos($path, '/')) === FALSE ? $path : substr($path, $pos+1) );
		if($lev <= 1) {
			
			return ' &gt; <a title="'.$title_link.' : '.$name.'" href="'.$link.'&amp;'.$parent_name.'='.$id_cat.'">'
				.$name.'</a>';
		} else {
			
			return $this->_recurseCategory($id_parent, $title_link, $link, $parent_name)
				.' &gt; <a title="'.$title_link.' : '.$name.'" href="'.$link.'&amp;'.$parent_name.'='.$id_cat.'">'
				.$name.'</a>';
		}
	}
	
	function getCategoryPath($id_cat, $lang_main, &$title_link, $link, $parent_name) {
		
		$categories = array();
		return'<a title="'.$title_link.' : '.$lang_main.'"  href="'.$link.'">'.$lang_main.'</a>'
			.$this->_recurseCategory($id_cat, $title_link, $link, $parent_name);
	}
	
}

class DoceboCourse {
	
	var $id_course;
	
	var $course_info;
	
	function _executeQuery($query_text) {
		
		$re = mysql_query($query_text);
		echo doDebug($query_text);
		return $re;
	}
	
	function _load() {
		
		$query_load = "
		SELECT idCategory, code, name, description, lang_code, 
			status, level_show_user, subscribe_method, linkSponsor, imgSponsor, img_course, 
			mediumTime, permCloseLO, userStatusOp, difficult, 
			show_progress, show_time, show_extra_info, show_rules, 
			date_begin, date_end, valid_time, max_num_subscribe, max_sms_budget, selling, prize
		FROM ".$GLOBALS['prefix_lms']."_course 
		WHERE idCourse = '".$this->id_course."'";
		$re_load = $this->_executeQuery($query_load);
		$this->course_info = mysql_fetch_assoc($re_load);
	}
	
	function DoceboCourse($id_course) {
		
		$this->id_course = $id_course;
		$this->_load();
	}
	
	function getAllInfo() {
		
		return $this->course_info;
	}
	
	function getValue($param) {
		
		return $this->course_info[$param];
	}
	
	function setValues($arr_new_values) {
		
		$re = true;
		if(empty($arr_new_values)) return $re;
		while(list($key, $value) = each($arr_new_values)) {
			
			$params[] = " ".$key." = '".$value."'";
		}
		$query = "
		UPDATE ".$GLOBALS['prefix_lms']."_course 
		SET ".implode(',', $params)
		." WHERE idCourse = '".$this->id_course."'";
		return $this->_executeQuery($query);
	}
	
	/**
	 * Find the idst of all the user subscribed to the course
	 * @param 	int 	$id_course 	the id of the course
	 * 
	 * @return 	array	idst
	 */
	function getSubscribed() {
		
		$acl_man	=& $GLOBALS['current_user']->getAclManager();
		
		$group_info = $acl_man->getGroup(FALSE, '/lms/course/'.$this->id_course.'/subscribed/alluser');
		$idst_group = $group_info[ACL_INFO_IDST];
		
		$members = $acl_man->getGroupAllUser($idst_group);
		return $members;
	}
	
}

/*******************************************************************************************/

/**
 * @param int 	$id_course			the id of the course
 * @param bool 	$subdived_for_level	if is true the array is in the form 
 *									[id_lv] => ([] => id_user, [] => id_user, ...), [id_lv] => ([] => id_user, ...)
 * @param int	$id_level			if is not false the array contains only a list of id_user of the level passed
 * @param bool	$exclude_waiting	if true exclude the user in wait status
 *
 * @return array	contains the id_user of the user subscribed, the structure is dependent of the other param
 */
function getSubscribed($id_course, $subdived_for_level = false, $id_level = false, $exclude_waiting = false) {
	
	$acl_man	=& $GLOBALS['current_user']->getAclManager();
	$id_users 	= array();
	
	$query_courseuser = "
	SELECT idUser, level, waiting 
	FROM ".$GLOBALS['prefix_lms']."_courseuser 
	WHERE idCourse = '".$id_course."'";
	if($exclude_waiting) $query_courseuser .= " AND waiting = 0";
	if($id_level !== false) {
		$query_courseuser .= " AND level = '".$id_level."'";
	}
	$re_courseuser = mysql_query($query_courseuser);
	while(list($id_user, $lv, $is_waiting) = mysql_fetch_row($re_courseuser)) {
		
		if($subdived_for_level === false) {
			
			$id_users[$id_user] = $id_user;
		} else {
			
			if( $is_waiting) {
				
				$id_users['waiting'][$id_user] = $id_user;
			} else {
				
				$id_users[$lv][$id_user] = $id_user;
			}
		}
	}
	return $id_users;
}

/**
 * @param int 	$id_course			the id of the course
 * @param bool 	$subdived_for_level	if is true the array is in the form 
 *									[id_lv] => ([] => id_user, [] => id_user, ...), [id_lv] => ([] => id_user, ...)
 * @param int	$id_level			if is not false the array contains only a list of id_user of the level passed
 * @param bool	$exclude_waiting	if true exclude the user in wait status
 *
 * @return array	contains the id_user of the user subscribed, the structure is dependent of the other param
 */
function getSubscribedInfo($id_course, $subdived_for_level = false, $id_level = false, $exclude_waiting = false, $status = false) {
	
	$acl_man	=& $GLOBALS['current_user']->getAclManager();
	$id_users 	= array();
	
	$query_courseuser = "
	SELECT c.idUser, c.level, c.waiting, c.status 
	FROM ".$GLOBALS['prefix_lms']."_courseuser c 
	LEFT JOIN ".$GLOBALS['prefix_fw']."_user u ON c.idUser = u.idst 
	WHERE c.idCourse = '".$id_course."'";
	if($exclude_waiting) $query_courseuser .= " AND c.waiting = 0";
	if($id_level !== false) {
		$query_courseuser .= " AND c.level = '".$id_level."'";
	}
	if($status !== false) {
		$query_courseuser .= " AND c.status = '".$status."'";
	}
	$query_courseuser .= " ORDER BY u.lastname, u.firstname";
	$re_courseuser = mysql_query($query_courseuser);
	while(list($id_user, $lv, $is_waiting, $status) = mysql_fetch_row($re_courseuser)) {
		
		if($subdived_for_level === false) {
			
			$id_users[$id_user] = array( 	'idUser' => $id_user,
											'lelvel' => $lv,
											'waiting' => $is_waiting,
											'status' => $status );
		} else {
			
			if( $is_waiting) {
				
				$id_users['waiting'][$id_user] = array( 'idUser' => $id_user,
														'level' => $lv,
														'waiting' => $is_waiting,
														'status' => $status );
			} else {
				
				$id_users[$lv][$id_user] = array( 	'idUser' => $id_user,
													'level' => $lv,
													'waiting' => $is_waiting,
													'status' => $status );
			}
		}
	}
	return $id_users;
}

/**
 * @param int 	$id_course			the id of the course
 * @param bool 	$subdived_for_level	if is true the array is in the form 
 *									[id_lv] => ([] => id_user, [] => id_user, ...), [id_lv] => ([] => id_user, ...)
 * @param int	$id_level			if is not false the array contains only a list of id_user of the level passed
 *
 * @return array	contains the id_user of the user subscribed and the relative level
 */
function getSubscribedLevel($id_course, $subdived_for_level = false, $id_level = false) {
	
	$acl_man	=& $GLOBALS['current_user']->getAclManager();
	$id_users 	= array();
	
	$query_courseuser = "
	SELECT idUser, level, waiting 
	FROM ".$GLOBALS['prefix_lms']."_courseuser 
	WHERE idCourse = '".$id_course."'";
	if($id_level !== false) {
		$query_courseuser .= " AND level = '".$id_level."'";
	}
	$re_courseuser = mysql_query($query_courseuser);
	while(list($id_user, $lv, $is_waiting) = mysql_fetch_row($re_courseuser)) {
		
		if($subdived_for_level === false) {
			
			$id_users[$id_user] = $lv;
		} else {
			
			if( $is_waiting) {
				
				$id_users['waiting'][$id_user] = $id_user;
			} else {
				
				$id_users[$lv][$id_user] = $id_user;
			}
		}
	}
	return $id_users;
}

/**
 * Find the idst of the group of a course that represent the level
 * @param 	int 	$id_course 	the id of the course
 * 
 * @return 	array	[lv] => idst, [lv] => idst
 */
function &getCourseLevel($id_course, $also_waiting = false) {
	
	$map 		= array();
	$levels 	= CourseLevel::getLevels();
	$acl_man	=& $GLOBALS['current_user']->getAclManager();
	
	
	// find all the group created for this menu custom for permission management
	foreach($levels as $lv => $name_level) {
		
		$group_info = $acl_man->getGroup(FALSE, '/lms/course/'.$id_course.'/subscribed/'.$lv);
		$map[$lv] 	= $group_info[ACL_INFO_IDST];
	}
	return $map;
}


/**
 * Create the group of a course that represent the level
 * @param 	int 	$id_course 	the id of the course
 * 
 * @return 	array	[lv] => idst, [lv] => idst
 */
function &createCourseLevel($id_course) {
	
	$map 		= array();
	$levels 	= CourseLevel::getLevels();
	$acl_man	=& $GLOBALS['current_user']->getAclManager();
	
	$idst_main = $acl_man->registerGroup( '/lms/course/'.$id_course.'/group/alluser', 
								'all the user of a course', 
								true );
								
	foreach($levels as $lv => $value) {
		$idst = $acl_man->registerGroup( '/lms/course/'.$id_course.'/subscribed/'.$lv, 
								'for course subscription in lms', 
								true );
		$map[$lv] = $idst;
	}
	foreach($map as $k => $id_g) {
		
		$acl_man->addToGroup($idst_main, $id_g);
	}
	return $map;
}

function getIDGroupAlluser($id_course) {
	
	$acl_man	=& $GLOBALS['current_user']->getAclManager();
	$info = $acl_man->getGroup(FALSE, '/lms/course/'.$id_course.'/group/alluser');
	
	return $info[ACL_INFO_IDST];
}

/**
 * @param int	$id_user 	the idst of the user
 *
 * @return 
 */
function &fromIdstToUser($id_user) {
	
	if(!is_array($id_user) || (count($id_user) == 0) ) return array();
	
	$users 		= array();
	$acl_man	=& $GLOBALS['current_user']->getAclManager();
	
	while(list(, $id_u) = each($id_user)) {
		
		$user_info = $acl_man->getUser($id_u, false);
		if( $user_info[ACL_INFO_LASTNAME].$user_info[ACL_INFO_FIRSTNAME] == '') {
			
			$users[] = $user_info[ACL_INFO_USERID];
		} else {
			
			$users[] = $user_info[ACL_INFO_LASTNAME].' '.$user_info[ACL_INFO_FIRSTNAME];
		}
	}
	return $users;
}


function &getCoursesInfo(&$courses) {
	
	if(empty($courses)) return array();
	
	$select = "
	SELECT idCourse, code, name, description 
	FROM ".$GLOBALS['prefix_lms']."_course
	WHERE idCourse IN (".implode(',', $courses).")";
	$re_select = mysql_query($select);
	while($assoc = mysql_fetch_assoc($re_select)) {
		
		$re_courses[$assoc['idCourse']] = array(
			'id' => $assoc['idCourse'],
			'code' => $assoc['code'], 
			'name' => $assoc['name'],
			'description' => $assoc['description'], 
		);
	}
	return $re_courses;
}


function &getCoursesName(&$courses) {
	
	if(empty($courses)) return array();
	
	$select = "
	SELECT idCourse, name 
	FROM ".$GLOBALS['prefix_lms']."_course
	WHERE idCourse IN (".implode(',', $courses).")";
	$re_select = mysql_query($select);
	while(list($id, $name) = mysql_fetch_row($re_select)) {
		
		$re_courses[$id] = $name;
	}
	return $re_courses;
}


function logIntoCourse($id_course, $gotofirst_page = true) {
	
	require_once($GLOBALS['where_lms'].'/lib/lib.track_user.php');
	
	if(!$GLOBALS['current_user']->isAnonymous() && isset($_SESSION['idCourse'])) {
	
		TrackUser::setActionTrack(getLogUserId(), $_SESSION['idCourse'], '', '');
	}
	
	//control if user can enter into the course selected
	list($level_c, $status_user, $waiting_user) = mysql_fetch_row(mysql_query("
	SELECT level, status, waiting 
	FROM ".$GLOBALS['prefix_lms']."_courseuser 
	WHERE idCourse = '".(int)$id_course."' AND idUser = '".getLogUserId()."'"));
	
	require_once($GLOBALS['where_lms'].'/lib/lib.course.php');
	$GLOBALS['course_descriptor'] = new DoceboCourse($id_course);
	$course_info = $GLOBALS['course_descriptor']->getAllInfo();
	$course_info['course_status'] 	= $GLOBALS['course_descriptor']->getValue('status');
	$course_info['user_status'] 	= $status_user;
	$course_info['waiting'] 		= $waiting_user;
	$course_info['level'] 			= $level_c;
	if($level_c == 2) $_SESSION['is_ghost'] = true;
	else $_SESSION['is_ghost'] = false;
	
	if(Man_Course::canEnterCourse($course_info)) {
		
		if($status_user == _CUS_SUBSCRIBED) {
			
			require_once($GLOBALS['where_lms'].'/lib/lib.stats.php');
			saveTrackStatusChange(getLogUserId(), $id_course, _CUS_BEGIN);
		}
	
		$now = date("Y-m-d H:i:s");
		$_SESSION['timeEnter'] 	= $now;
		$_SESSION['idCourse'] 		= (int)$id_course;
		$_SESSION['levelCourse'] 	= $level_c;
		
		$GLOBALS['current_user']->loadUserSectionST('/lms/course/private/'.$level_c.'/');
		$GLOBALS['current_user']->SaveInSession();
		
		TrackUser::createSessionCourseTrack();
		
		// NOTE: load first page of the course/*
		$first_page = firstPage();
		
		$_SESSION['current_main_menu'] = $first_page['idMain'];
		if($first_page['modulename'] != '') {
			
			jumpTo( 'index.php?modname='.$first_page['modulename'].'&op='.$first_page['op'].'&sel_module='.$first_page['idModule']);
		}
	} else {
		
		$_SESSION['current_main_menu'] = '1';
		$_SESSION['sel_module_id'] = '1';
		$GLOBALS['modname'] = 'course';
		$GLOBALS['op'] 		= 'mycourses';
	}
}

?>