<?php

/************************************************************************/
/* DOCEBO LMS - Learning managment system								*/
/* ============================================							*/
/*																		*/
/* Copyright (c) 2005													*/
/* http://www.docebo.com												*/
/*																		*/
/* This program is free software. You can redistribute it and/or modify	*/
/* it under the terms of the GNU General Public License as published by	*/
/* the Free Software Foundation; either version 2 of the License.		*/
/************************************************************************/

/**
 * @version  $Id: lib.coursepath.php 113 2006-03-08 18:08:42Z ema $
 * @category Course managment
 * @author	 Fabio Pirovano <fabio [at] docebo [dot] com>
 */

class Selector_CoursePath {
	
	var $show_filter = true;
	
	var $filter = array();
	
	var $current_page = '';
	
	var $current_selection = array();
	
	/**
	 * Class constructor
	 */
	function Selector_CoursePath() {
		
		$this->show_filter = true;
	}
	
	function enableFilter() {
		
		$this->show_filter = true;
	}
	
	function disableFilter() {
		
		$this->show_filter = false;
	}
	
	/**
	 * return the current status in a pratic format
	 * @return string a string with the data used for reloading the current status
	 */
	function getStatus() {
		
		$status = array(
			'page' 					=> $this->current_page,
			'filter' 				=> urlencode(serialize($this->filter)), 
			'show_filter' 			=> $this->show_filter, 
			'current_selection' 	=> urlencode(serialize($this->current_selection)) );
		return urlencode(serialize($status));
	}
	
	/**
	 * reset the current status to te given one
	 * @param string	$status_serialized a valid status saved using getStatus
	 */
	function loadStatus(&$status_serialized) {
		
		if($status_serialized == '') return ;
		$status = unserialize(urldecode($status_serialized));
		
		$this->current_page			= $status['page'];
		$this->filter				= unserialize(urldecode($status['filter']));
		$this->show_filter			= $status['show_filter'];
		$this->current_selection	= unserialize(urldecode($status['current_selection'])) ;
	}
	
	function parseForAction($array_action) {
	
	}
	
	function parseForState($array_state) {
		
		// older selection
		if(isset($array_state['coursepath_selected'])) {
			
			$this->current_selection = unserialize(urldecode($array_state['coursepath_selected']));
		}
		// add last selection
		if(isset($array_state['new_coursepath_selected'])) {
			while(list($id_cpath) = each($_POST['new_coursepath_selected'])) {
				
				$this->current_selection[$id_cpath] = $id_cpath;
			}
		}
	}
	
	function stateSelection() {
		
		return Form::getHidden('coursepath_selected', 'coursepath_selected', urlencode(serialize($this->current_selection)) );
	}
	
	function getSelection() {
		
		return $this->current_selection;
	}
	
	function resetSelection($new_selection) {
		
		$this->current_selection = $new_selection;
	}
	
	function loadCoursepathSelector() {
		
		require_once($GLOBALS['where_framework'].'/lib/lib.newtypeone.php');
		require_once($GLOBALS['where_framework'].'/lib/lib.form.php');
		
		$lang =& DoceboLanguage::createInstance('coursepath', 'lms');
		
		// Filter
		$this->filter['coursepath_name'] = ( isset($_POST['coursepath_filter_name']) ? $_POST['coursepath_filter_name'] : '' );
		if($this->show_filter === true) {
			$form = new Form();
			$GLOBALS['page']->add(
				$form->getOpenFieldset($lang->def('_COURSEPATH_FILTER'))
				.Form::getTextfield($lang->def('_FILTER_NAME'), 'coursepath_filter_name', 'coursepath_filter_name', '255', 
					( isset($_POST['coursepath_filter_name']) ? $_POST['coursepath_filter_name'] : '' ))
				.$form->openButtonSpace() 
				.$form->getButton('coursepath_filter', 'coursepath_filter', $lang->def('_SEARCH'))
				.$form->closeButtonSpace()
				.$form->getCloseFieldset()
			, 'content');
		}
		// End Filter
		
		$tb = new TypeOne($GLOBALS['visuItem'], $lang->def('_COURSE_PATH_CAPTION'), $lang->def('_COURSE_PATH_SUMMARY'));
		
		$tb->initNavBar('ini_cpath', 'button');
		$ini = $tb->getSelectedElement();
		
		$select = "
		SELECT idPath, path_name, path_descr ";
		$query_coursepath = " 
		FROM ".$GLOBALS['prefix_lms']."_coursepath
		WHERE 1 ";
		if($GLOBALS['current_user']->getUserLevelId() != ADMIN_GROUP_GODADMIN) {
			
			require_once($GLOBALS['where_lms'].'/lib/lib.course_managment.php');
			
			$course_man = new AdminCourseManagment();
			$all_path =& $course_man->getUserAllCoursePaths( getLogUserId() );
			
			if(empty($all_path)) {
				
				$query_coursepath .= " AND 0 ";
			} else {
				
				$query_coursepath .= " AND idPath IN (".implode(',', $all_path).") ";
			}
		}
		if($this->filter['coursepath_name'] != '') {
			$query_coursepath .= " AND path_name LIKE '%".$this->filter['coursepath_name']."%'";
		}
		list($tot_coursepath) = mysql_fetch_row(mysql_query("SELECT COUNT(*) ".$query_coursepath));
		
		$query_coursepath .= " 
		ORDER BY path_name 
		LIMIT ".$ini.",".(int)$GLOBALS['visuItem'];
		
		$re_coursepath = mysql_query($select.$query_coursepath);
		
		$type_h = array('image', '', '', '');
		$cont_h = array(
			'<span class="access-only">'.$lang->def('_COURSE_PATH_SELECTION').'</span>', 
			$lang->def('_COURSE_PATH_NAME'), 
			$lang->def('_COURSE_PATH_DESC')
		);
		$tb->setColsStyle($type_h);
		$tb->addHead($cont_h);
		while(list($id_path, $name, $descr) = mysql_fetch_row($re_coursepath)) {
			
			$tb_content = array(
				Form::getInputCheckbox('new_coursepath_selected_'.$id_path, 'new_coursepath_selected['.$id_path.']', $id_path, 
					isset($this->current_selection[$id_path]), ''), 
				'<label for="new_coursepath_selected_'.$id_path.'">'.$name.'</label>',
				'<label for="new_coursepath_selected_'.$id_path.'">'.$descr.'</label>'
			);
			$tb->addBody($tb_content);
			if(isset($this->current_selection[$id_path])) unset($this->current_selection[$id_path]);
		}
		
		$GLOBALS['page']->add(
			$tb->getTable()
			.$tb->getNavBar($ini, $tot_coursepath)
			.$this->stateSelection(), 'content');
	}
	
}

class CoursePath_Manager {

	var $acl;
	
	var $aclManager;
	
	function CoursePath_Manager() {
		
		$this->acl = new DoceboACL();
		$this->aclManager =& $this->acl->getAclManager();
	}
	
	function _executeQuery($query) {
		
		$rs = mysql_query($query);
		$GLOBALS['page']->add('<!-- '.$query.' : '.mysql_error().' -->'."\n", 'debug');
		return $rs;
	}
	
	function _getPathTable() {
		return $GLOBALS['prefix_lms'].'_coursepath';
	}
	
	function _getPathCourseTable() {
		return $GLOBALS['prefix_lms'].'_coursepath_courses';
	}
	
	function _getPathUserTable() {
		return $GLOBALS['prefix_lms'].'_coursepath_user';
	}
	
	/**
	 * @param	array	an array with the value of the id to search
	 *
	 * @return	array 	an array with id => name of the course path
	 */
	function &getNames(&$coursepath) {
		
		$re_coursepath = array();
		if(empty($coursepath)) return array();
		
		$select = "
		SELECT idPath, path_name 
		FROM ".$this->_getPathTable()."
		WHERE idPath IN (".implode(',', $coursepath).")";
		$re_select = mysql_query($select);
		while(list($id, $name) = mysql_fetch_row($re_select)) {
			
			$re_coursepath[$id] = $name;
		}
		return $re_coursepath;
	}
	
	/**
	 * @param	int $id		the idPath of a coursepath
	 *
	 * @return	array 	an array with [idPath] [path_code] [path_name] [path_descr] [subscribe_method]
	 */
	function getCoursepathInfo($id) {
		
		$select = "
		SELECT idPath, path_code, path_name, path_descr, subscribe_method 
		FROM ".$this->_getPathTable()."
		WHERE idPath = '".$id."'";
		$re_select = mysql_query($select);
		if(!$re_select) return false;
		return  mysql_fetch_assoc($re_select);
	}
	
	/**
	 * return all the courses directly assigned to a list coursepath
	 * @param array 	$coursepaths	the id of the coursepath
	 *
	 * @return array 	the id of the courses (id => id, ...)
	 **/
	function getAllCourses($coursepaths) {
		
		$courses = array();
		if(empty($coursepaths)) return array();
		$query = "
		SELECT DISTINCT idCourse
		FROM ".$this->_getPathCourseTable()." 
		WHERE idPath  IN (".implode(',', $coursepaths).") ";
		$re_courses = $this->_executeQuery($query);
		while(list($id) = mysql_fetch_row($re_courses)) {
			
			$courses[$id] = $id;
		}
		return $courses;
	}
	
	
	/**
	 * return all the courses directly assigned to a list coursepath
	 * @param int 	$id_path	the id of the coursepath
	 *
	 * @return array 	the id of the users (id => id, ...)
	 **/
	function getSubscribed($id_path) {
		
		$users = array();
		$query = "
		SELECT idUser 
		FROM ".$this->_getPathUserTable()." 
		WHERE idPath = '".$id_path."' ";
		$re_users = $this->_executeQuery($query);
		while(list($id) = mysql_fetch_row($re_users)) {
			
			$users[$id] = $id;
		}
		return $users;
	}
	
	function checkPrerequisites($prerequisites, &$courses_info) {
		
		require_once($GLOBALS['where_lms'].'/lib/lib.course.php');

		if($prerequisites == '') return true;
		$arr_prere = explode(',', trim($prerequisites));
		if($arr_prere == false) return true;
		while(list(,$id_c) = each($arr_prere)) {
			
			if($courses_info[$id_c]['user_status'] != _CUS_END) return false;
		}
		return true;
	}
}

?>