<?php

class Upgrade_Coursepath extends Upgrade {
	
	var $platfom = 'lms';
	
	var $mname = 'coursepath';
	
	/**
	 * upgrade the module version
	 * @param string 	$start_version 	the start version, automaticaly prooceed to the next
	 *
	 * @return mixed 	true if the version jump was successful, else an array with an error code and an error message
	 * 					array( 'error_code', 'error_msg' )
	 **/
	function oneStepUpgrade($start_version) {
		
		switch($start_version) {
			case "2.0.4" : {
				
				$query = "CREATE TABLE `learning_coursepath` (
				  `idPath` int(11) NOT NULL auto_increment,
				  `path_code` varchar(255) NOT NULL default '',
				  `path_name` varchar(255) NOT NULL default '',
				  `path_descr` text NOT NULL,
				  `subscribe_method` tinyint(1) NOT NULL default '0',
				  PRIMARY KEY  (`idPath`)
				);";
				if(!$this->db_man->query($query)) return $this->_getErrArray($start_version, 1);
				
				
				$query = "CREATE TABLE `learning_coursepath_courses` (
				  `idPath` int(11) NOT NULL default '0',
				  `idCourse` int(11) NOT NULL default '0',
				  `prerequisites` text NOT NULL,
				  `sequence` int(3) NOT NULL default '0',
				  PRIMARY KEY  (`idPath`,`idCourse`)
				);";
				if(!$this->db_man->query($query)) return $this->_getErrArray($start_version, 2);
				
				
				$query = "CREATE TABLE `learning_coursepath_user` (
				  `idPath` int(11) NOT NULL default '0',
				  `idUser` int(11) NOT NULL default '0',
				  `waiting` tinyint(1) NOT NULL default '0',
				  `subscribed_by` int(11) NOT NULL default '0',
				  PRIMARY KEY  (`idPath`,`idUser`)
				);";
				if(!$this->db_man->query($query)) return $this->_getErrArray($start_version, 3);
				
				$this->end_version = '3.0';
				return true;
			};break;
			
		}
		return true;
	}
}

?>